Attribute VB_Name = "Main"
' Written by Donn Edwards <donn@support.co.za>
' Copyright (c) 2000 SOS Support Operating Systems
' All rights reserved
'
' This module is used by both NewCode.exe and FixCode.exe
'
Option Explicit
Global iDBug As Integer ' Used for debugging
Global MyTime As Long ' Used for tracking elapsed time
Public strContent As String ' Contents of the last file
Public strFileOld As String ' The last file name

'// Used for File Compare
Public Type ObjectList
    strName As String ' Name of the object
    lngLineOld As Long ' Line Number in Old file
    lngLineNew As Long ' Line Number in New file
    iType As Integer   ' Object Type
    ptrParent As Integer ' Pointer to parent object
End Type

' Declarations for the Find File section from www.freevbcode.com
' and from Q154821
Public Const FILE_ATTRIBUTE_READONLY = &H1
Public Const FILE_ATTRIBUTE_HIDDEN = &H2
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const FILE_ATTRIBUTE_TEMPORARY = &H100
Public Const FILE_ATTRIBUTE_COMPRESSED = &H800
Public Const MAX_PATH = 260
Public Const OF_READ = &H0
Public Const OF_SHARE_DENY_NONE = &H40
Public Const OFS_MAXPATHNAME = 128

Public Type FILETIMEREC
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type SYSTEMTIMEREC
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIMEREC
    ftLastAccessTime As FILETIMEREC
    ftLastWriteTime As FILETIMEREC
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

'// API calls for the find file and File Open functions
Declare Function ShellExecute Lib "shell32.dll" Alias _
   "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As _
   String, ByVal lpFile As String, ByVal lpParameters As _
   String, ByVal lpDirectory As String, ByVal nShowCmd As _
   Long) As Long
   
Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" _
    (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long

Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" _
    (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
    
Public Declare Function FileTimeToSystemTime Lib "kernel32" _
     (lpFileTime As FILETIMEREC, lpSystemTime As SYSTEMTIMEREC) As Long
     
Public Declare Function SystemTimeToFileTime Lib "kernel32" _
     (lpSystemTime As SYSTEMTIMEREC, lpFileTime As FILETIMEREC) As Long
       
Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long


Public Sub DBug(ByVal strIn As String)
'******************************************************************************
'*                                                                            *
'* Name:    DBug                                                              *
'*                                                                            *
'* Purpose: Display indented debugging information                            *
'*                                                                            *
'******************************************************************************
  If iDBug < 1 Then
    Debug.Print vbCrLf & strIn    ' Start on a new line
  Else
    Debug.Print Space$(iDBug) & strIn
  End If
  iDBug = iDBug + 1
End Sub

Public Sub DBugStr(ByVal strIn As String)
'******************************************************************************
'*                                                                            *
'* Name:    DBugStr                                                           *
'*                                                                            *
'* Purpose: Display Debugging information without further indents             *
'*                                                                            *
'******************************************************************************
  If iDBug < 1 Then
    Debug.Print strIn
  Else
    Debug.Print Space$(iDBug) & strIn
  End If
End Sub

Public Sub DBugOut()
'******************************************************************************
'*                                                                            *
'* Name:    DBugOut                                                           *
'*                                                                            *
'* Purpose: Go back one level when debugging                                  *
'*                                                                            *
'******************************************************************************
  iDBug = iDBug - 1
End Sub

Public Sub Process_Error(ByVal vstrProcName As String)
'******************************************************************************
'*                                                                            *
'* Name:    Process_Error                                                     *
'*                                                                            *
'* Purpose: Display the error message                                         *
'*                                                                            *
'******************************************************************************
Dim strMsg As String

    '// Setup message string
    strMsg = "An error has occurred in at procedure '" & vstrProcName & "'." & vbCrLf & vbCrLf & _
             "Error Number: " & CStr(Err.Number) & vbCrLf & vbCrLf & Err.Description & vbCrLf
          
    '// Inform user.
    Beep
    MsgBox strMsg, vbCritical
  
End Sub

Public Sub OpenThisDoc(ByVal handle As Long, FileName As String)
'******************************************************************************
'*                                                                            *
'* Name:    OpenThisDoc                                                       *
'*                                                                            *
'* Purpose: Use the API call to open the file or folder                       *
'*                                                                            *
'******************************************************************************
Dim x As Long
  On Error Resume Next
  x = ShellExecute(handle, "Open", FileName, "", "", 1)
  On Error GoTo 0
End Sub

Public Function StripNulls(f As String) As String
' // This is from the FindFiles application from www.freevbcode.com
    StripNulls = Left$(f, InStr(1, f, Chr$(0)) - 1)
End Function


