Attribute VB_Name = "RUF"
'////////////// CODE FOR HANDLING RECENTLY USED FILES (RUF'S) ////////////
'////////////////// BY COLIN CAPRANI (ccaprani@clubi.ie) /////////////////
'YOU ARE FREE TO USE THIS CODE IN ANY WAY ON CONDITION THAT YOU E-MAIL ME
'/////////////////////////////////////////////////////////////////////////

'//////////////////////////// DIRECTIONS /////////////////////////////////
'1. FILL IN THE FOLLOWING CONSTANTS BELOW & THE VARIABLES IN THE /////////
'   checkForPrevious SUB FOR YOUR PARTICULAR APP /////////////////////////
'2. PLACE mnuRUF WITH AN INDEX = 1 IN YOUR APP'S MENU - SEE DEMO /////////
'3. DELETE THE THREE HIGHLIGHTED REFERENCES TO THE TEXTBOX OF THE DEMO ///
'4. USE REGEDIT TO SEE HOW THE INFO IS STORED IN THE REGISTRY ////////////
'/////////////////////////////////////////////////////////////////////////

'/////////////////////////////////////////////////////////////////////////
'///// HEALTH WARNING: MIS-USE OF REGISTRY CAN DAMAGE YOUR COMPUTER //////
'/////////////////////////////////////////////////////////////////////////

Option Explicit
'application name for the registry key
Const APP = "RUFdemo - C. Caprani"
'sub key for recent files
Const SECTION = "Recent Files"
'This variable references the form you are working off
Dim USER_FORM As Form
'This variable references the location where the user enters maximum
'number of RUF's. Probably in Tools-Options-File
Dim MAX_FILES_TXT As Object
'noRUF is the current number of RUF's
'MAX_FILES is the maximum allowed noumber of RUF's
'these are stored in a "Config" subkey
Dim noRUF As Integer, MAX_FILES As Integer

'///////////////// THIS SUB IS ONLY REQUIRED FOR THE DEMO ////////////////
Private Sub doText(newFile As String)
'just add the new text to the text that is there with a return at the end
USER_FORM.Text1.Text = USER_FORM.Text1.Text & newFile & vbCrLf
End Sub

Private Sub addNewFile(newFile As String)
'determine if we need to add a menu item
doLoadMenuItem
'rotate the files in the registry
doRotateFiles (newFile)
'////////////////// NEXT LINE IS REQUIRED IN DEMO ONLY ///////////////////
doText (newFile) 'add to the text box
'/////////////////////////////////////////////////////////////////////////
'fill the menu now
doMenu
End Sub

Sub doCheckfiles(newFile As String)
Dim i As Integer, j As Integer

'check if newFile is already in the menu
For i = 1 To USER_FORM.mnuRUF.Count '1 to no. files in the menu
    If USER_FORM.mnuRUF(i).Caption = newFile Then     'it is in the menu
        Select Case i
            Case 1
                'do nothing if the selection is the first menu item
            Case noRUF            'selection is the last menu item
                'shift all files down the list by one by looping
                'back from the last file (noRUF)
                For j = noRUF - 1 To 1 Step -1
                    USER_FORM.mnuRUF(j + 1).Caption = _
                        USER_FORM.mnuRUF(j).Caption
                Next j
            Case Else
                'loop backwards from the users selection
                For j = i - 1 To 1 Step -1
                    'move all items down the menu
                    USER_FORM.mnuRUF(j + 1).Caption = _
                        USER_FORM.mnuRUF(j).Caption
                Next j
        End Select
        'make the first item the latest selection
        USER_FORM.mnuRUF(1).Caption = newFile
        
'////////////////// NEXT LINE IS REQUIRED IN DEMO ONLY ///////////////////
        doText (newFile) 'just update the textbox so you know it has worked
'/////////////////////////////////////////////////////////////////////////

        Exit For
    ElseIf i = USER_FORM.mnuRUF.Count Then    'it is not in the menu
       addNewFile (newFile)         'go through the other procedure
       Exit For
    End If
Next i
'check if the MAX_FILES value has changed & reduce menu items accordingly
doRationaliseMenu
End Sub

Sub doLoadMenuItem()
getMaxFiles
If noRUF < MAX_FILES Then
'haven't reached MAX_FILES yet so increase number of RUF's in menu
    noRUF = noRUF + 1
'if MAX_FILES or noRUF = 1 we would raise an error as menu item 1
'is already loaded
    If Not noRUF = 1 Then
        Load USER_FORM.mnuRUF(noRUF)
    End If
    SaveSetting APP, "Config", "noRUF", noRUF   'saves latest noRUF value
End If
End Sub

Sub checkForPrevious() 'loads the RUF list with the app start-up
Dim i As Integer, fileTxt As String

'This variable references the form you are working off
Set USER_FORM = Form1
'This constant references the location where the user enters maximum
'number of RUF's. Probably in Tools-Options-File
Set MAX_FILES_TXT = Form1.maxRufTxt

'This line checks for any previous settings
'if there are none then this is the first time the
'program has been run on this machine
fileTxt = GetSetting(APP, SECTION, "1")

If fileTxt = "" Then    'no previous settings found

'//////////////////////////////////////////////////////////////////////////
'PLACE ANY CODE THAT YOU WANT TO EXECUTE THE FIRST TIME THE APP IS RUN HERE
    MsgBox "Welcome to Colin Caprani's RUF Demo", , "RUF Demo - C. Caprani"
'//////////////////////////////////////////////////////////////////////////

    'saves the current noRUF's, zero as this is the first use
    SaveSetting APP, "Config", "noRUF", noRUF
    'set and save an initial max_files
    MAX_FILES = 3
    SaveSetting APP, "Config", "MAX_FILES", MAX_FILES
    MAX_FILES_TXT.Text = 3 'sets textbox value to current max_files
Else                    'settings exist, get them
    MAX_FILES = GetSetting(APP, "Config", "MAX_FILES", MAX_FILES)
    noRUF = GetSetting(APP, "Config", "noRUF", noRUF)
    MAX_FILES_TXT.Text = MAX_FILES

    'now get RUF's and read them into the menu so they are ready when
    'the user first sees the form
    For i = 1 To noRUF
        fileTxt = GetSetting(APP, SECTION, i)
        'the first menu item was already loaded at design time
        If Not i = 1 Then Load USER_FORM.mnuRUF(i)
        USER_FORM.mnuRUF(i).Caption = fileTxt
    Next i
End If
End Sub

Private Sub doMenu() 'handles a change in MAX_FILES or noRUF and fills the menu
Dim i As Integer, fileTxt As String

If noRUF = MAX_FILES Then
'simply fills menu items from the data in the registry
    For i = 1 To MAX_FILES
        fileTxt = GetSetting(APP, SECTION, i)
        USER_FORM.mnuRUF(i).Caption = fileTxt
    Next i
'the user hasn't used the program enough yet to have filled the menu up
'to MAX_FILES or else the user has recently increased MAX_FILES
ElseIf noRUF < MAX_FILES Then
    For i = 1 To noRUF
        'get filename for each RUF
        fileTxt = GetSetting(APP, SECTION, i)
        'the menu items are already loaded so just add text
        USER_FORM.mnuRUF(i).Caption = fileTxt
    Next i
'the user could select a MAX_FILES value lower than the current noRUF value
Else
    'delete unwanted RUF's in the list
    doRationaliseMenu
    'update the menu
    doMenu
End If

End Sub

Private Sub doRotateFiles(newFile As String) 'moves RUF's along the registry list
Dim i As Integer

'replace the last key with the second last and so on until
'the first is now the second key and we can read our new
'filename into the "1" position unless the file the user
'has just selected is the same as last time
If Not newFile = GetSetting(APP, SECTION, "1") Then
    For i = MAX_FILES - 1 To 1 Step -1
        SaveSetting APP, SECTION, i + 1, GetSetting(APP, SECTION, i)
    Next i
    SaveSetting APP, SECTION, "1", newFile
End If
End Sub

Sub doRationaliseMenu() 'tidies up registry and menu
Dim i As Integer

getMaxFiles 'in case it has changed
If noRUF > MAX_FILES Then
    'save the new MAX_FILES value
    SaveSetting APP, "Config", "MAX_FILES", MAX_FILES
    'remove the menu item and registry key of each filename that we
    'now don't want on our menu
    For i = MAX_FILES + 1 To noRUF 'we haven't changed the value of noRUF yet
        Unload USER_FORM.mnuRUF(i)
        DeleteSetting APP, SECTION, i
    Next i
    'now read the MAX_FILES value into noRUF
    noRUF = GetSetting(APP, "Config", "MAX_FILES", MAX_FILES)
End If
End Sub

Private Sub getMaxFiles()
'get value of MAX_FILES from textbox and save it, checking for silly input
If IsNumeric(MAX_FILES_TXT) Then
    MAX_FILES = CInt(MAX_FILES_TXT)
Else:
    MsgBox "Please input a number in future, ok"
    MAX_FILES = 4
End If
If 1 > MAX_FILES Or MAX_FILES > 20 Then MAX_FILES = 4
SaveSetting APP, "Config", "MAX_FILES", MAX_FILES
'read it back in to the MAX_FILES variable
MAX_FILES = GetSetting(APP, "Config", "MAX_FILES", MAX_FILES)
'put MAX_FILES back into textbox
MAX_FILES_TXT = MAX_FILES
End Sub
