Attribute VB_Name = "Module1"
'Written by Ormond Stock Mar 2001
'E&OE. Not fully tested. Comments, corrections, improvements please to ormond@osa.co.nz.
Option Explicit
Global Const ATTR_DIRECTORY = 16
Public CopyError As String
Function CopyFiles _
(srcPath As String, dstPath As String, SlashS As Integer, SlashE As Integer, _
FilePat As String, SlashA As Integer, SlashM As Integer, SlashD As Integer, _
CopyDate As Date, SlashH As Integer, SlashR As Integer, SlashU As Integer, _
SlashY As Integer, SlashK As Integer, SlashEX As Integer, ExcludedFiles As String, _
CopyResult As String) As Integer

Dim DirOK As Integer, i As Integer
Dim DirReturn As String

Dim dCount As Integer
Dim CurrFile$
Dim CurrDir$
Dim dstPathBackup As String
Dim ResetArchive As Boolean
Dim FileExists As Boolean
'Dim Filehandle As Integer
'Dim FileReturn As Long
Dim ThisOneReadOnly As Boolean
Dim ThisOneHidden As Boolean
Dim ThisOneSystem As Boolean
Dim ThisOneArchive As Boolean
Dim AttributesThisOne As Integer
'Dim FileDate As Date
Dim ThisFileDate As Date
Dim FirstPos As Integer
Dim f%
On Error GoTo DirErr
CurrDir$ = CurDir$
   
'If Path lacks a "\", add one to the end
If Right$(srcPath, 1) <> "\" Then srcPath = srcPath & "\"
srcPath = UCase$(srcPath)
If Right$(dstPath, 1) <> "\" Then dstPath = dstPath & "\"
dstPath = UCase$(dstPath)
dstPathBackup = dstPath

'Count number of subdirectories (dCount)

DirReturn = Dir(srcPath & "*.*", ATTR_DIRECTORY)
Do While DirReturn <> ""
'Make sure we bypass "." and ".."
If DirReturn <> "." And DirReturn <> ".." Then
     If (GetAttr(srcPath & DirReturn) And ATTR_DIRECTORY) = ATTR_DIRECTORY Then
         ' It's a dir. Add it to dirlist
         dCount = dCount + 1
     End If
End If
DirReturn = Dir
Loop
'Now set size of array to cope with all directories
ReDim d(dCount + 1) As String
dCount = 0
  
'Initialize var to hold filenames
DirReturn = Dir(srcPath & "*.*", ATTR_DIRECTORY)
   
'Find all subdirs
Do While DirReturn <> ""
    ' Make sure we don't do anything with "." and "..", they aren't really files
    If DirReturn <> "." And DirReturn <> ".." Then
        If (GetAttr(srcPath & DirReturn) And ATTR_DIRECTORY) = ATTR_DIRECTORY Then
            ' It's a dir. Add it to dirlist
            dCount = dCount + 1
            d(dCount) = srcPath & DirReturn
        End If
    End If
    DirReturn = Dir
Loop
   
'Now do all the files matching FilePath (and make sure we don't do the dirs)
DirReturn = Dir(srcPath & FilePat, 7)

'Find all files
Do While DirReturn <> ""
    ' Establish attributes of this file
    AttributesThisOne = GetAttr(srcPath & DirReturn)

    If ((AttributesThisOne And vbReadOnly) <> 0) Then
        ThisOneReadOnly = True
        Else
        ThisOneReadOnly = False
    End If
    If ((AttributesThisOne And vbHidden) <> 0) Then
        ThisOneHidden = True
        Else
        ThisOneHidden = False
    End If
    If ((AttributesThisOne And vbSystem) <> 0) Then
        ThisOneSystem = True
        Else
        ThisOneSystem = False
    End If
    If ((AttributesThisOne And vbArchive) <> 0) Then
        ThisOneArchive = True
        Else
        ThisOneArchive = False
    End If

    'Make sure we don't get a dir
    If Not ((AttributesThisOne And ATTR_DIRECTORY) = ATTR_DIRECTORY) Then
        'It's a file.  Establish whether it exists already.
        On Error Resume Next
        f% = FreeFile
        Open dstPath & DirReturn For Input As #f%
        Close #f%
        If Err = 0 Then
            FileExists = True
        Else
            FileExists = False
        End If
        
        'Check if /A or /M is set and archive attribute isn't
        If (CBool(SlashA) Or CBool(SlashM)) Then
            If Not ThisOneArchive Then GoTo BogOut
        End If
        
        'Check if /M means archive bit is to be reset.
        If CBool(SlashM) Then
            ResetArchive = True
        Else
            ResetArchive = False
        End If
        
        'Check if hidden or system without /H
        If Not CBool(SlashH) And (ThisOneSystem Or ThisOneHidden) Then
            GoTo BogOut
        End If
        
        'Check if /D is set
        If CBool(SlashD) Then
            If Len(CopyDate) = 0 Then 'date wasn't entered, so only copy if newer than destination
                CopyDate = FileDateTime(dstPath & DirReturn)
            End If
            ThisFileDate = FileDateTime(srcPath & DirReturn)
            ThisFileDate = Left(Str(ThisFileDate), 11)
            If InStr(ThisFileDate, "/") = 2 Then
                ThisFileDate = "0" & ThisFileDate
            End If
            If ThisFileDate < CopyDate Then GoTo BogOut
        End If
        
        'Is this file one of the ones excluded by file pattern?
        If CBool(SlashEX) And InStr(dstPath & DirReturn, ExcludedFiles) > 0 Then
            GoTo BogOut
        End If
        
        'Are we required to only copy files which exist?
        If CBool(SlashU) And Not FileExists Then
            GoTo BogOut
        End If
               
        'Does the file exist and we require prompting?
        If FileExists And Not CBool(SlashY) Then
            f% = MsgBox("The file " & dstPath & DirReturn & " already exists. Do you wish to overwrite it?", 4 + 32 + 256)
            If f% <> 6 Then
                GoTo BogOut
            End If
        End If
        
        'If FileExists check if Read only and are we allowed to overcopy
        If FileExists Then
            If ((GetAttr(dstPath & DirReturn) And vbReadOnly) <> 0) And Not SlashR Then
                GoTo BogOut
            End If
        End If
        
        'If we've got this far we can copy!
        If CBool(SlashS) And Not CBool(SlashE) Then 'With /S create directories now
            On Error GoTo PathErr
            ChDir dstPath
            On Error GoTo DirErr
        End If
        FileCopy srcPath & DirReturn, dstPath & DirReturn
        
        If ResetArchive Then  'reset the archive bit
                SetAttr (srcPath & DirReturn), AttributesThisOne - vbArchive
        End If
        
        'If /K is set and original file is ReadOnly then need to set new file as ReadOnly
        If SlashK And ThisOneReadOnly Then
                SetAttr (dstPath & DirReturn), GetAttr(dstPath & DirReturn) + vbReadOnly
        End If

End If  'End of loop
        
BogOut:
      DirReturn = Dir
Loop

' Now do all subs
For i = 1 To dCount
      
    ' Check the 'IncludeSubDirs' value. If it's true, we have to make
    ' a dir called 'd(i)' in dstPath, and then assign dstPath & d(i) as
    ' dstPath
    If CBool(SlashE) Or CBool(SlashS) Then
        On Error GoTo PathErr
        dstPath = dstPath & Right$(d(i), Len(d(i)) - Len(srcPath))
        'If the Path exists, then this will work out, if not, an error
        'will be generated and trapped, and the dir will be made
        If CBool(SlashE) Then 'With /E create directories now
            ChDir dstPath
            On Error GoTo DirErr
        End If
     Else
        'Since we aren't doing subdirectories, we're finished
        CopyFiles = True
        GoTo ExitFunc
    End If
    DirOK = CopyFiles(d(i), dstPath, SlashS, SlashE, FilePat, SlashA, SlashM, SlashD, CopyDate, _
    SlashH, SlashR, SlashU, SlashY, SlashK, SlashEX, ExcludedFiles, CopyResult)

    ' Reset dstPath to the value assigned at the argument-line
    dstPath = dstPathBackup

Next
'CopyFiles = True

ExitFunc:
    ChDir CurrDir$
Exit Function

DirErr:
'   CopyFiles = False
Resume ExitFunc

PathErr:
' Didn't find the Dir'ed path
If Err = 75 Or Err = 76 Then
    MkDir dstPath
    Resume Next
End If
GoTo DirErr
End Function

