VERSION 5.00
Begin VB.UserControl GetFile 
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3060
   ScaleHeight     =   285
   ScaleWidth      =   3060
   ToolboxBitmap   =   "GetFile.ctx":0000
   Begin VB.CommandButton cmdGetFile 
      Height          =   285
      Left            =   2760
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   0
      UseMaskColor    =   -1  'True
      Width           =   285
   End
   Begin VB.TextBox txtFile 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2775
   End
End
Attribute VB_Name = "GetFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const OPEN_BMP = 101
Private Const SAVE_BMP = 102

Public Enum GetFileTypeConstants
    gtfOpen
    gtfSave
End Enum

Private m_GetFileType As GetFileTypeConstants
Private m_DialogTitle As String
Private m_Flags As Long
Private m_Filter As String
Private m_FilterIndex As Long
Private m_InitDir As String

Private Sub ChangeButtonBmp()
    If m_GetFileType = gtfOpen Then
        Set cmdGetFile.Picture = LoadResPicture(OPEN_BMP, vbResBitmap)
    Else
        Set cmdGetFile.Picture = LoadResPicture(SAVE_BMP, vbResBitmap)
    End If
End Sub

Private Sub cmdGetFile_Click()
    Dim dlg As CdlgEx
    Set dlg = New CdlgEx
    
    With dlg
        .DialogTitle = m_DialogTitle
        .Flags = m_Flags
        .Filter = m_Filter
        .FilterIndex = m_FilterIndex
        .InitDir = m_InitDir
        
        .CancelError = True
        
        On Error GoTo ErrHandler
            If m_GetFileType = gtfOpen Then
                .ShowOpen
            Else
                .ShowSave
            End If
        On Error GoTo 0
        
        txtFile.Text = .FileName
        txtFile.ToolTipText = .FileTitle
        txtFile.SetFocus
    End With
    
ErrHandler:
    
End Sub

Private Sub UserControl_InitProperties()
    ChangeButtonBmp
End Sub

Private Sub UserControl_Resize()
    Dim w As Single
    Dim h As Single
    
    h = ScaleHeight
    w = ScaleWidth - h
    
    txtFile.Move 0, 0, w, h
    cmdGetFile.Move w, 0, h, h
End Sub


Public Property Get GetFileType() As GetFileTypeConstants
    GetFileType = m_GetFileType
End Property

Public Property Let GetFileType(ByVal eGetFileType As GetFileTypeConstants)
    m_GetFileType = eGetFileType
    PropertyChanged "GetFileType"
    Call ChangeButtonBmp
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        m_GetFileType = .ReadProperty("GetFileType", gtfOpen)
        m_DialogTitle = .ReadProperty("DialogTitle", "")
        m_Filter = .ReadProperty("Filter", "")
        m_Flags = .ReadProperty("Flags", 0)
        m_InitDir = .ReadProperty("InitDir", "")
    End With
    Call ChangeButtonBmp
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "GetFileType", m_GetFileType, gtfOpen
        .WriteProperty "DialogTitle", m_DialogTitle, ""
        .WriteProperty "Filter", m_Filter, ""
        .WriteProperty "Flags", m_Flags, 0
        .WriteProperty "InitDir", m_InitDir, ""
    End With
End Sub

Public Property Get DialogTitle() As String
    DialogTitle = m_DialogTitle
End Property

Public Property Let DialogTitle(ByVal sDialogTitle As String)
    m_DialogTitle = sDialogTitle
End Property

Public Property Get Flags() As Long
    Flags = m_Flags
End Property

Public Property Let Flags(ByVal lFlags As Long)
    m_Flags = lFlags
End Property

Public Property Get Filter() As String
    Filter = m_Filter
End Property

Public Property Let Filter(ByVal sFilter As String)
    m_Filter = sFilter
End Property

Public Property Get FilterIndex() As Long
    FilterIndex = m_FilterIndex
End Property

Public Property Let FilterIndex(ByVal lFilterIndex As Long)
    m_FilterIndex = lFilterIndex
End Property

Public Property Get InitDir() As String
    InitDir = m_InitDir
End Property

Public Property Let InitDir(ByVal sInitDir As String)
    m_InitDir = sInitDir
End Property

Public Property Get FileName() As String
    FileName = txtFile.Text
End Property

Public Property Get FileTitle() As String
    FileTitle = txtFile.ToolTipText
End Property

Public Property Get Locked() As Boolean
    Locked = txtFile.Locked
End Property
Public Property Let Locked(bLocked As Boolean)
    txtFile.Locked = bLocked
End Property
