VERSION 5.00
Begin VB.Form FTestBed 
   Caption         =   "Test Bed"
   ClientHeight    =   2955
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6675
   LinkTopic       =   "Form1"
   ScaleHeight     =   2955
   ScaleWidth      =   6675
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCompact 
      Caption         =   "Get Compact Path"
      Height          =   435
      Left            =   4920
      TabIndex        =   11
      Top             =   2460
      Width           =   1695
   End
   Begin VB.CommandButton cmdRelative 
      Caption         =   "Get Relative Path"
      Height          =   435
      Left            =   4920
      TabIndex        =   6
      Top             =   1260
      Width           =   1695
   End
   Begin VB.TextBox txtCompact 
      Height          =   315
      Left            =   1320
      TabIndex        =   10
      Top             =   2400
      Width           =   3075
   End
   Begin VB.TextBox txtLong 
      Height          =   315
      Left            =   1320
      TabIndex        =   8
      Text            =   "C:\Program Files\Microsoft Visual Studio\VB98\Wizards\Appwiz.ocx"
      Top             =   2040
      Width           =   5295
   End
   Begin VB.TextBox txtRelative 
      Height          =   315
      Left            =   1320
      TabIndex        =   5
      Top             =   840
      Width           =   5295
   End
   Begin VB.TextBox txtTo 
      Height          =   315
      Left            =   1320
      TabIndex        =   3
      Text            =   "C:\Windows\System\mapi.dll"
      Top             =   480
      Width           =   5295
   End
   Begin VB.TextBox txtFrom 
      Height          =   315
      Left            =   1320
      TabIndex        =   1
      Text            =   "C:\Windows\System32\Drivers"
      Top             =   120
      Width           =   5295
   End
   Begin VB.Label lblTag 
      Caption         =   "Compact Path:"
      Height          =   255
      Index           =   4
      Left            =   60
      TabIndex        =   9
      Top             =   2460
      Width           =   1215
   End
   Begin VB.Label lblTag 
      Caption         =   "Long Path:"
      Height          =   255
      Index           =   3
      Left            =   60
      TabIndex        =   7
      Top             =   2100
      Width           =   1215
   End
   Begin VB.Label lblTag 
      Caption         =   "Relative Path:"
      Height          =   255
      Index           =   2
      Left            =   60
      TabIndex        =   4
      Top             =   900
      Width           =   1215
   End
   Begin VB.Label lblTag 
      Caption         =   "To File:"
      Height          =   255
      Index           =   1
      Left            =   60
      TabIndex        =   2
      Top             =   540
      Width           =   1215
   End
   Begin VB.Label lblTag 
      Caption         =   "From Directory:"
      Height          =   255
      Index           =   0
      Left            =   60
      TabIndex        =   0
      Top             =   180
      Width           =   1215
   End
End
Attribute VB_Name = "FTestBed"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*******************************************************************************
' MODULE:       FTestBed
' FILENAME:     C:\My Code\vb\Misc\PathRoutines\FTestBed.frm
' AUTHOR:       Phil Fresle
' CREATED:      13-Jan-2000
' COPYRIGHT:    Copyright 2000 Frez Systems Limited. All Rights Reserved.
'
' DESCRIPTION:
' Shows how the path routines may be used.
'
' This is 'free' software with the following restrictions:
'
' You may not redistribute this code as a 'sample' or 'demo'. However, you are free
' to use the source code in your own code, but you may not claim that you created
' the sample code. It is expressly forbidden to sell or profit from this source code
' other than by the knowledge gained or the enhanced value added by your own code.
'
' Use of this software is also done so at your own risk. The code is supplied as
' is without warranty or guarantee of any kind.
'
' Should you wish to commission some derivative work based on the code provided
' here, or any consultancy work, please do not hesitate to contact us.
'
' Web Site:  http://www.frez.co.uk
' E-mail:    sales@frez.co.uk
'
' MODIFICATION HISTORY:
' 1.0       13-Jan-2000
'           Phil Fresle
'           Initial Version
'*******************************************************************************
Option Explicit

Private Declare Function GetDC Lib "user32" _
    (ByVal hwnd As Long) As Long
    
Private Declare Function ReleaseDC Lib "user32" _
    (ByVal hwnd As Long, _
     ByVal hdc As Long) As Long

'*******************************************************************************
' cmdCompact_Click (SUB)
'
' PARAMETERS:
' None
'
' DESCRIPTION:
' Tests taking a path string and compacting it to fit in a textbox
'*******************************************************************************
Private Sub cmdCompact_Click()
    Dim lWidth  As Long
    Dim lDC     As Long
    
    ' Width of destination text box adjusted by 4 pixels for border
    lWidth = ScaleX(txtCompact.Width, Me.ScaleMode, vbPixels) - 4
    
    ' For speed, if the form font is the same as the textbox font you could
    ' use Me.hdc instead of getting a device context for the textbox
    lDC = GetDC(txtCompact.hwnd)
    
    txtCompact.Text = GetCompactPath(txtLong.Text, lDC, lWidth)
    
    ' Don't forget to tidy up after yourself
    ReleaseDC txtCompact.hwnd, lDC
End Sub

'*******************************************************************************
' cmdRelative_Click (SUB)
'
' PARAMETERS:
' None
'
' DESCRIPTION:
' Tests taking a path for a directory and a path for a file and working out the
' relative path to the file from the directory
'*******************************************************************************
Private Sub cmdRelative_Click()
    txtRelative.Text = GetRelativePath(txtFrom.Text, txtTo.Text)
End Sub

