VERSION 5.00
Begin VB.Form fMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "txt2pad"
   ClientHeight    =   1215
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   3390
   Icon            =   "fMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1215
   ScaleWidth      =   3390
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtFolder 
      Height          =   285
      Left            =   60
      TabIndex        =   1
      Top             =   360
      Width           =   3255
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse"
      Height          =   375
      Left            =   1560
      TabIndex        =   2
      Top             =   720
      Width           =   855
   End
   Begin VB.CommandButton cmdMakePad 
      Caption         =   "&Make"
      Height          =   375
      Left            =   2460
      TabIndex        =   3
      Top             =   720
      Width           =   855
   End
   Begin VB.Label lblCap 
      AutoSize        =   -1  'True
      Caption         =   "&Start Folder"
      Height          =   195
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   810
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileEditExt 
         Caption         =   "&Edit Extensions"
      End
      Begin VB.Menu mnuFileBar0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpHelp 
         Caption         =   "&Help"
      End
      Begin VB.Menu mnuHelpBar0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "fMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' file    : fMain.frm
' revised : 06 Jun 2000
' project : ptxt2pad.vbp
' author  : Amanda Gunther
' email   : redbird77@earthlink.net
' www     : http://home.earthlink.net/~redbird77

Option Explicit

Private WFD        As WIN32_FIND_DATA
Private m_hFile    As Long
Private m_sCurName As String

Private m_sExt()   As String   ' Array of user selected extensions.
Private m_iOut     As Integer  ' File number of output (.hjt) file.

Private Sub cmdBrowse_Click()
'
' Displays a "Broswe for Folder" dialog.  Places the user selected folder
' path in the text box only if the user did not cancel the dialog.
'
    Dim sFolder As String
    
    sFolder = BrowseForFolder(Me.hwnd, "Choose Folder")
    
    If sFolder <> "" Then txtFolder = sFolder
    
End Sub

Private Sub cmdMakePad_Click()
    '
    ' TreePad syntax
    ' --------------
    ' <node>
    ' Node Text
    ' Node Level
    ' Article Text
    ' <end node> 5P9i0s8y19Z
    '
    Dim iExt  As Integer
    Dim sName As String
    Dim sPath As String
    Dim iPos  As Integer
    Dim iPos2 As Integer
    
    On Error GoTo errHandler
    '
    ' Do not make the TreePad file if no folder is indicated or there are
    ' no extensions in the ext.txt file.
    '
    If txtFolder = "" Then
        MsgBox "You must enter a value for the Start Folder.", vbInformation
        txtFolder.SetFocus
        Exit Sub
    End If
    
    iExt = GetExtensions
    
    If iExt = -1 Then
        MsgBox "No extensions found in " & ProperPath(App.Path) & EXT_NAME, _
               vbExclamation, "TreePad file not created"
        Exit Sub
    End If
    
    If iExt = -2 Then
        MsgBox "The file, " & EXT_NAME & ", could not be found in the " & _
               "application's directory.", vbExclamation, _
               "TreePad file not created"
        Exit Sub
    End If
    
    Me.MousePointer = vbHourglass
    '
    ' Get the name of the TreePad file to create.  The file name is simply
    ' the name of the folder to search in.  I'm sure there are easier
    ' ways of doing this...
    '
    sName = ProperPath(txtFolder)
    
    iPos = InStrRev(sName, "\")
    iPos2 = InStrRev(sName, "\", iPos - 1)
    
    If iPos2 Then
        sName = Mid$(sName, iPos2 + 1, iPos - iPos2 - 1)
    Else
        sName = Left$(sName, 1)
    End If

'    sName = Dir$(Left$(sName, Len(sName) - 1), _
'                 vbDirectory + vbArchive + vbHidden + vbReadOnly)
    
    sPath = ProperPath(txtFolder) & sName & ".hjt"
    '
    ' Printing directly to the file is faster than concatenating strings onto
    ' a buffer string.  When a string is long (i.e. > 10000 bytes) a statement
    ' such as sBuf = sBuf & sSomeText slows down the program.
    '
    ' You can considerably speed up the string building process by using a
    ' technique of initializing a large buffer of spaces and then inserting
    ' text into the buffer using "Mid" on the left hand side of the assignment.
    ' But for this small app, I find it eaiser just to print directly to the file.
    '
    m_iOut = FreeFile
    
    Open sPath For Output Access Write As #m_iOut
    
    Print #m_iOut, BEG_FILE
    Print #m_iOut, BEG_NODE
    '
    ' There is only one "0" node.  This is the root node.
    ' The file name actually determines the root node's text.
    ' So even if you have a file with a root node named "VB Code Snippets",
    ' if you name the file "VB.hjt", the root node text will be
    ' displayed as "VB".  It's is easiest to have the file name and
    ' root node names match.
    '
    Print #m_iOut, sName
    Print #m_iOut, "0"
    Print #m_iOut, END_NODE
    '
    ' Entry into the recursive EnumFilesAll sub.
    '
    EnumFilesAll ProperPath(txtFolder), 0

    Close #m_iOut
    
    Me.MousePointer = vbDefault
    
    MsgBox "TreePad file " & vbCrLf & sPath & vbCrLf & "has been created.", _
           vbInformation, "Success"
    
    Exit Sub
           
errHandler:
    '
    ' Path not found
    '
    If Err.Number = 76 Then
        MsgBox ProperPath(txtFolder) & " does not exist", _
               vbExclamation, "TreePad file not created"
    End If

    Me.MousePointer = vbDefault
    Exit Sub
    
End Sub

Private Sub Form_Load()

    txtFolder = GetSetting(App.Title, "Settings", "InputFolder")
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '
    ' Save txtFolder value in registry (for now using VB methods).
    '
    SaveSetting App.Title, "Settings", "InputFolder", txtFolder
    Set fMain = Nothing
    
End Sub

Private Sub mnuFileEditExt_Click()

    Dim lRet     As Long
    Dim sExtPath As String
    
    sExtPath = ProperPath(App.Path) & EXT_NAME
    
    lRet = ShellEx(Me.hwnd, sExtPath)
    
    If lRet = 2 Then
        MsgBox sExtPath & vbCrLf & _
               "could not be found in the application's directory.", _
               vbExclamation, "File Error"
    ElseIf lRet <= 32 Then
        MsgBox "An error ocurred while trying to open the file.", _
               vbExclamation, "File Error"
    End If
    
End Sub

Private Sub mnuFileExit_Click()
    Unload fMain
End Sub

Private Sub mnuHelpAbout_Click()
    fAbout.Show vbModal
End Sub

Private Sub mnuHelpHelp_Click()
    Dim lRet     As Long
    Dim sHlpPath As String
    
    sHlpPath = ProperPath(App.Path) & HLP_NAME
    '
    ' Repeated, move to sub/function.
    '
    lRet = ShellEx(Me.hwnd, sHlpPath)
    
    If lRet = 2 Then
        MsgBox sHlpPath & vbCrLf & _
               "could not be found in the application's directory.", _
               vbExclamation, "File Error"
    ElseIf lRet <= 32 Then
        MsgBox "An error ocurred while trying to open the file.", _
               vbExclamation, "File Error"
    End If
End Sub

Private Sub EnumFilesAll(ByRef sStartPath As String, _
                         ByRef iLevel As Integer)
'
' The workhorse sub of the program.  This sub enumerates through all the
' directories and files in the user specified starting dir, building the
' TreePad file as the sub progresses.
'
    Dim i        As Integer
    Dim iArt     As Integer
    Dim iDirs    As Integer
    Dim iFiles   As Integer
    Dim sDirs()  As String
    Dim sFiles() As String
    
    'On Error Resume Next
    
    DoEvents
    '
    ' Get a handle to the first file/folder in the specified path.
    '
    m_hFile = FindFirstFile(sStartPath & "*.*", WFD)
    '
    ' If such a file/folder exists...
    '
    If m_hFile <> INVALID_HANDLE_VALUE Then
        Do
            '
            ' Trim the null of the file/folder path.  m_sCurName is simply
            ' the name of the file/folder, it is not a full path.
            '
            m_sCurName = Left$(WFD.cFileName, _
                         InStr(WFD.cFileName, vbNullChar) - 1)
            '
            ' If the "place" WFD.cFilename refers to is a folder (not
            ' including .. and .) then...
            '
            If (WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) Then
                If Asc(m_sCurName) <> 46 Then
                    '
                    ' Add the folder to the cache of folders.  This
                    ' array will be enumerated through at the end of
                    ' the sub.
                    '
                    ReDim Preserve sDirs(iDirs)

                    sDirs(iDirs) = m_sCurName
                    iDirs = iDirs + 1
                End If
            '
            ' Else the "place" is a file not a folder.
            '
            Else
                If IncludeFile(m_sCurName) Then
                    '
                    ' Add the file to the file cache array.
                    ' You could add the node here, yet the nodes then
                    ' would not be sorted.
                    '
                    ReDim Preserve sFiles(iFiles)

                    sFiles(iFiles) = m_sCurName
                    iFiles = iFiles + 1
                End If
            End If
        '
        ' Loop while the API function FindNextFile does not return 0
        ' meaning no more valid files/folders could be found.
        '
        Loop While FindNextFile(m_hFile, WFD)
        '
        ' Close the file search handle.
        '
        FindClose m_hFile
    End If
    
    If iFiles Then
        '
        ' If any valid files are found, then sort the files and add each
        ' one as a child node to the parent (directory) node.
        '
        QuickSort sFiles(), 0, UBound(sFiles)
   
        For i = 0 To UBound(sFiles)
            Print #m_iOut, BEG_NODE
            Print #m_iOut, sFiles(i)
            Print #m_iOut, CStr(iLevel + 1)
            '
            ' Using Binary mode allows for files w/ extensions such as
            ' .gif, .jpg to be added.  Yet this really isn't pratical
            ' since TreePad doesn't display images.  These files will
            ' most either show up as junk characters or nothing at all.
            '
            iArt = FreeFile
            
            Open sStartPath & sFiles(i) For Binary Access Read As #iArt
                Print #m_iOut, Input(LOF(iArt), #iArt)
            Close #iArt
    
            Print #m_iOut, END_NODE
        Next
    End If
    
    If iDirs Then
    
        QuickSort sDirs, 0, UBound(sDirs)
        
        For i = 0 To UBound(sDirs)
            Print #m_iOut, BEG_NODE
            Print #m_iOut, sDirs(i)
            Print #m_iOut, CStr(iLevel + 1)
            Print #m_iOut, END_NODE
            '
            ' If any directories were found in current directory, call
            ' the EnumFilesAll sub, with each of those dirs as the
            ' starting path.
            '
            EnumFilesAll ProperPath(sStartPath & sDirs(i)), iLevel + 1
        Next
    End If
    
End Sub

Public Function GetExtensions() As Integer

    Dim iExt     As Integer
    Dim sAll     As String
    Dim sExt     As String
    Dim i        As Integer: i = -1
    Dim sExtPath As String
    
    sExtPath = ProperPath(App.Path) & EXT_NAME
    
    On Error GoTo errHandler
    
    iExt = FreeFile
    
    Erase m_sExt
    
    Open sExtPath For Input As #iExt
    
    Do While Not EOF(iExt)
    
        i = i + 1
        ReDim Preserve m_sExt(i)
        '
        ' Line of text = extension
        '
        Line Input #iExt, m_sExt(i)
        '
        ' If "extension" is ":all" then, erase all array elements, and
        ' add ":all" as the only one.
        '
        If m_sExt(i) = ":all" Then
            ReDim m_sExit(0)
            m_sExt(0) = ":all"
            GetExtensions = 0
            Exit Do
        End If
        
        m_sExt(i) = LCase$(m_sExt(i))
    Loop
    
    Close #iExt
    '
    ' i will equal -1 of no extensions at all were found.
    '
    GetExtensions = i
    
    Exit Function
    
errHandler:
    '
    ' File not found
    '
    If Err.Number = 53 Then
'        MsgBox sExtPath & vbCrLf & _
'               "could not be found in the application's directory.", _
'               vbExclamation, "File Error"
        GetExtensions = -2
    End If
    
    Exit Function
   
End Function

Private Function IncludeFile(sFilename As String) As Boolean
    
    Dim i    As Integer
    Dim iPos As Integer
    Dim sExt As String
    '
    ' Find the position of the last dot in the file name.
    '
    iPos = InStrRev(sFilename, ".")
    '
    ' If the pos <> 0 then the extension is everthing from the character
    ' after the dot to the end of the file name.
    '
    If iPos Then sExt = LCase$(Mid$(sFilename, iPos + 1))
    '
    ' Do not allow TreePad files within TreePad files.
    '
    If sExt = "hjt" Then
        IncludeFile = False
        Exit Function
    End If
    '
    ' If user indicated all extensions (this includes files with no
    ' extensions) are valid, then return True.
    '
    If m_sExt(0) = ":all" Then
        IncludeFile = True
        Exit Function
    End If
    '
    ' Iterate through the valid extension array and see if the passed in file's
    ' extension matches any ext in the array.
    '
    For i = 0 To UBound(m_sExt)
        '
        ' If a match is made, exit immeadiately.
        '
        If sExt = m_sExt(i) Then
            IncludeFile = True
            Exit Function
        End If
    Next
    '
    ' No match is found, do not include file text in TreePad.
    '
    IncludeFile = False
    
End Function
