Attribute VB_Name = "mBrowse"
' file    : mBrowse.bas
' revised : 06 Jun 2000
' project : ptxt2pad.vbp
' author  : Amanda Gunther
' email   : redbird77@earthlink.net
' www     : http://home.earthlink.net/~redbird77

Option Explicit

Private Const MAX_PATH             As Long = 260
Private Const BIF_RETURNONLYFSDIRS As Long = 1

Private Type BrowseInfo
    hWndOwner      As Long
    pIDLRoot       As Long
    pszDisplayName As Long
    lpszTitle      As Long
    ulFlags        As Long
    lpfnCallback   As Long
    lParam         As Long
    iImage         As Long
End Type

Private Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
    ByVal hMem As Long)

Private Declare Function SHBrowseForFolder Lib "shell32" ( _
    lpbi As BrowseInfo) _
As Long

Private Declare Function SHGetPathFromIDList Lib "shell32" ( _
    ByVal pidList As Long, _
    ByVal lpBuffer As String) _
As Long
    
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" ( _
    ByVal lpString1 As String, _
    ByVal lpString2 As String) _
As Long

Public Function BrowseForFolder(hWndOwner As Long, _
                                sTitle As String) As String

    Dim BI       As BrowseInfo
    Dim iPos     As Integer
    Dim lpIDList As Long
    Dim lResult  As Long
    Dim sPath    As String
    
    With BI
        .hWndOwner = hWndOwner
        .lpszTitle = lstrcat(sTitle, vbNullChar)
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With
    '
    ' <From VB6 Help File Re: SHBrowseForFolder>
    '
    ' Returns the address of an item identifier list that specifies
    ' the location of the selected folder relative to the root of
    ' the namespace. If the user chooses the Cancel button in the
    ' dialog box, the return value is NULL.
    '
    lpIDList = SHBrowseForFolder(BI)
    '
    ' If user did not cancel...
    '
    If lpIDList Then
        '
        ' Fill buffer with nulls.
        '
        sPath = String$(MAX_PATH, vbNullChar)
        '
        ' Get pointer to the item identifier of the selected folder.
        '
        SHGetPathFromIDList lpIDList, sPath
    
        CoTaskMemFree lpIDList
        '
        ' Strip out the null terminator.
        '
        iPos = InStr(sPath, vbNullChar)
        
        If iPos Then sPath = Left$(sPath, iPos - 1)
        
    End If
    '
    ' Return value is the user selected folder, "" if user canceled.
    '
    BrowseForFolder = sPath
    
End Function
