Attribute VB_Name = "mMisc"
' file    : mMic.bas
' revised : 06 Jun 2000
' project : ptxt2pad.vbp
' author  : Amanda Gunther
' email   : redbird77@earthlink.net
' www     : http://home.earthlink.net/~redbird77

Option Explicit
'
' TreePad constants
'
Public Const BEG_FILE As String = "<hj-Treepad version 0.9>"
Public Const BEG_NODE As String = "<node>"
Public Const END_NODE As String = "<end node> 5P9i0s8y19Z"
Public Const EXT_NAME As String = "ext.txt"
Public Const HLP_NAME As String = "help.txt"
'
' Find constants
'
Public Const FILE_ATTRIBUTE_DIRECTORY As Long = &H10
Public Const INVALID_HANDLE_VALUE     As Long = -1
Public Const MAX_PATH                 As Long = 260
'
' Find functions
'
Public Declare Function FindFirstFile Lib "kernel32" _
    Alias "FindFirstFileA" ( _
    ByVal lpFileName As String, _
    lpFindFileData As WIN32_FIND_DATA) _
As Long
    
Public Declare Function FindNextFile Lib "kernel32" _
    Alias "FindNextFileA" ( _
    ByVal hFindFile As Long, _
    lpFindFileData As WIN32_FIND_DATA) _
As Long
    
Public Declare Function FindClose Lib "kernel32" ( _
    ByVal hFindFile As Long) _
As Long
'
' Find types
'
Private Type FILETIME
    dwLowDateTime  As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime   As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime  As FILETIME
    nFileSizeHigh    As Long
    nFileSizeLow     As Long
    dwReserved0      As Long
    dwReserved1      As Long
    cFileName        As String * MAX_PATH
    cAlternate       As String * 14
End Type
'
' ShellExecute constants/functions
'
Private Const SW_SHOWNORMAL As Long = 1

Public Declare Function ShellExecute Lib "shell32.dll" _
    Alias "ShellExecuteA" ( _
    ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) _
As Long

Public Function ShellEx(lhWndParent As Long, sPath As String) As Long
'
' Specific to this app.
'
    Dim lRet As Long
    
    lRet = ShellExecute(lhWndParent, "open", sPath, _
                        vbNullString, vbNullString, SW_SHOWNORMAL)
    
    ShellEx = lRet
End Function

Public Sub QuickSort(sArray() As String, lLow As Long, lUp As Long)
    '
    ' This sub sorts considerably faster than the bubble sort I was using.
    ' Credit for the entire sub goes to the nifty folk at VBNet
    ' WWW - http://www.mvps.org/vbnet
    '
    Dim tmpLo As Long
    Dim tmpUp As Long
    Dim X     As String
    Dim Y     As String
   
    tmpLo = lLow
    tmpUp = lUp
   
    X = sArray((lLow + lUp) / 2)

    While (tmpLo <= tmpUp)
        While (StrComp(sArray(tmpLo), X, vbTextCompare) = -1 And tmpLo < lUp)
            tmpLo = tmpLo + 1
        Wend
    
        While (StrComp(X, sArray(tmpUp), vbTextCompare) = -1 And tmpUp > lLow)
           tmpUp = tmpUp - 1
        Wend
 
        If (tmpLo <= tmpUp) Then
            Y = sArray(tmpLo)
            sArray(tmpLo) = sArray(tmpUp)
            sArray(tmpUp) = Y
            
            tmpLo = tmpLo + 1
            tmpUp = tmpUp - 1
        End If
    Wend
   
   If (lLow < tmpUp) Then QuickSort sArray, lLow, tmpUp
   If (tmpLo < lUp) Then QuickSort sArray, tmpLo, lUp
  
End Sub

Public Function ProperPath(sPath As String) As String
    ProperPath = sPath & IIf(Right$(sPath, 1) = "\", "", "\")
End Function

