Attribute VB_Name = "FixModule"
Option Explicit
' Written by Donn Edwards <donn@support.co.za>
' Copyright (c) 2000 SOS Support Operating Systems
' All rights reserved

Public Sub FixCodeMain(ByVal strPath As String, ByVal strControlFile As String)
'******************************************************************************
'*                                                                            *
'* Name:    FixCodeMain                                                       *
'*                                                                            *
'* Purpose: Process the changes.ini file to figure out what needs to be       *
'*          changed                                                           *
'*                                                                            *
'******************************************************************************
On Error GoTo FixCodeMain_Error
DBug "FixCodeMain: " & strPath & "; " & strControlFile

Dim nControlFile As Integer, strControl As String, intControl As Integer
Dim strFind As String, strReplace As String, strFile As String
Dim WFD As WIN32_FIND_DATA ' File Find data structure
Dim hFile As Long, eFile As Integer
Dim lngBefore As Long, lngAfter As Long
Const intCommand As Integer = 1
Const intFile As Integer = 2
Const intFind As Integer = 3
Const intReplace As Integer = 4
' Version 1.1:
Const intFileList As Integer = 5
Const intFindList As Integer = 3 ' 6
Const intReplaceList As Integer = 4 ' 7
Const intFileDir As Integer = 8
'
  '// Open the control file
  eFile = 3
  nControlFile = 2
  intControl = 0
  strFileOld = ""
  strContent = ""
  MyTime = Second(Time) + Minute(Time) * 60 + Hour(Time) * 60 * 24
  Open strPath & "\_FixCode.txt" For Output As eFile ' Error Log
  Print #eFile, strControlFile & " " & Now & vbCrLf
  Close #eFile
  Open strControlFile For Input As nControlFile
  While Not EOF(nControlFile) ' #nControlFile
    Line Input #nControlFile, strControl ' Read the line
    strControl = RTrim(strControl) ' Trim training blanks
    'DBugStr strControl
    If Left(strControl, 1) = "[" Then
        If (intControl = intReplace) Or (intControl = intReplaceList) Then ' intReplace
            '// Now make the changes required
            Call FixUpdateFile(strFile, strFind, strReplace, strPath)
        End If ' intReplace
        intControl = intCommand
    End If
    Select Case intControl ' intControl
    Case intCommand:
        If strControl = "[File]" Then
            intControl = intFile
            strFind = ""
            strReplace = ""
            strFile = ""
        End If
        If strControl = "[Find]" Then
            intControl = intFind
            strFind = ""
        End If
        If strControl = "[Replace]" Then
            intControl = intReplace
            strReplace = ""
        End If
        If strControl = "[FileList]" Then
            intControl = intFileList
            strFind = ""
            strReplace = ""
            strFile = ""
        End If
        If strControl = "[FileDir]" Then
            intControl = intFileDir
            strFind = ""
            strReplace = ""
            strFile = ""
        End If
        If strControl = "[FindList]" Then
            intControl = intFind
            strFind = ""
        End If
        If strControl = "[ReplaceList]" Then
            intControl = intReplace
            strReplace = ""
        End If
    Case intFile:
        If Len(strControl) > 0 Then strFile = strPath & strControl & "|"
    Case intFileList:
        If Len(strControl) > 0 Then strFile = strFile & strPath & strControl & "|"
    Case intFind, intFindList:
        strFind = strFind & strControl & vbCrLf
    Case intReplace, intReplaceList:
        strReplace = strReplace & strControl & vbCrLf
    Case intFileDir: '// Build a directory of file names
        If Len(strControl) > 0 Then ' strControl
            strFind = strPath & strControl ' Get the wild card with path
            If Len(Dir(strFind)) > 0 Then ' Dir
                '// Find the first file name
                hFile = FindFirstFile(strFind, WFD)
                If (hFile > 0) And ((WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY) Then  ' File Name
                    strReplace = StripNulls(WFD.cFileName)
                    If Len(strReplace) > 0 Then ' Found one file
                        strFile = strFile & strPath & strReplace & "|"
                        'DBugStr strReplace
                    End If ' Found one file
                    strReplace = ""
                End If  ' File Name
                '// Find the subsequent file names
                If hFile > 0 Then ' hFile
                    While FindNextFile(hFile, WFD) ' FindNextFile
                        If ((WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY) Then ' File Name
                            strReplace = StripNulls(WFD.cFileName)
                            If Len(strReplace) > 0 Then ' Found one more file
                                strFile = strFile & strPath & strReplace & "|"
                                'DBugStr strReplace
                            End If ' Found one more file
                            strReplace = ""
                        End If ' File Name
                    Wend ' FindNextFile
                End If ' hFile
            End If ' Dir
            strFind = ""
            strReplace = ""
        End If ' strControl
    Case Else ' intControl
    End Select ' intControl
  Wend ' #nControlFile
  Close #nControlFile
  If intControl = intReplace Then Call FixUpdateFile(strFile, strFind, strReplace, strPath)
  'If intControl = intReplaceList Then Call FixUpdateFile(strFile, strFind, strReplace)
  FixCode1.lblVersion.ForeColor = &H80000012 ' black
  FixCode1.lblVersion.Caption = " Version " & App.Major & "." & App.Minor & "." & App.Revision
  lngAfter = Second(Time) + Minute(Time) * 60 + Hour(Time) * 60 * 24 - MyTime + 1
  FixCode1.lblProgress.Caption = CStr(lngAfter \ 60) & " minutes and " & CStr(lngAfter Mod 60) & " seconds elapsed" ' Elapsed time
  FixCode1.Refresh

FixCodeMain_Done: DBugOut
  Exit Sub

FixCodeMain_Error:
  Call Process_Error("FixCodeMain")
  Resume FixCodeMain_Done

End Sub

Private Sub FixUpdateFile(ByVal strFileList As String, ByVal strFind As String, ByVal strReplace As String, ByVal strPath As String)
'******************************************************************************
'*                                                                            *
'* Name:    FixUpdateFile                                                        *
'*                                                                            *
'* Purpose: Open the file, load the text, make the changes, save the text     *
'*                                                                            *
'******************************************************************************

On Error GoTo FixUpdateFile_Error
DBug "FixUpdateFile" ' & strFile & ";" & Replace(strFind, vbCrLf, "|") & ";" & Replace(strReplace, vbCrLf, "|")
Dim nFile As Integer, strLine As String, strFile As String
Dim i As Long, j As Long, eFile As Integer, lngStart As Long, lngCount As Long
Dim lngBefore As Long, lngAfter As Long
  nFile = 1
  eFile = 3
  i = 1
  j = InStr(i + 1, strFileList, "|") '// Get the first file name
  While j > 0 ' WHILE j
    'strContent = ""
    FixCode1.lblVersion.Caption = CStr(Second(Time) + Minute(Time) * 60 + Hour(Time) * 60 * 24 - MyTime + 1) & " seconds" ' Elapsed time
    strFile = Mid$(strFileList, i, j - i) ' Get the file name
    FixCode1.lblProgress.Caption = strFile
    FixCode1.Refresh
    On Error GoTo NextFile
    If Len(strContent) > 0 And strFile = strFileOld Then ' Content
        '// Don't need to open the file and read it again
        DBugStr "FixUpdateFile: Not re-reading " & strFile
    Else ' Content
        strContent = ""
        strFileOld = ""
        DBugStr "FixUpdateFile: reading " & strFile
        Open strFile For Input As nFile
        On Error GoTo FixUpdateFile_Error
        While Not EOF(nFile) ' #nFile
            Line Input #nFile, strLine ' Read the line
            strLine = RTrim(strLine) & vbCrLf ' Trim training blanks
            strContent = strContent & strLine
        Wend ' #nFile
        Close #nFile ' #nFile
        
    End If ' Content
    lngBefore = Len(strContent)
    lngCount = -1
    lngStart = 1
    '// This is the most important line of the entire program:
    '   The replace action happens here
    strContent = Replace(strContent, strFind, strReplace, lngStart, lngCount, vbTextCompare)
    lngAfter = Len(strContent)
    If lngBefore <> lngAfter Then
        FixCode1.lblVersion.ForeColor = &H80000012 ' black
    Else
        '// Assume no replacement happened. This is not necessarily true
        Open strPath & "\_FixCode.txt" For Append As eFile ' Error Log
        Print #eFile, strFile & ":" & vbCrLf & "[Find]" & vbCrLf & strFind
        Close #eFile
        FixCode1.lblVersion.ForeColor = &HFF0000    ' blue
    End If
    On Error GoTo NextFile
    Open strFile For Output As nFile
    On Error GoTo FixUpdateFile_Error
    Print #nFile, strContent
    Close #nFile ' #nFile
    strFileOld = strFile
NextFile:
    i = j + 1
    j = InStr(i + 1, strFileList, "|") '// Get the next file name
  Wend ' WHILE j
  'FixCode1.lblProgress.Caption = " "
FixUpdateFile_Done: DBugOut
  Exit Sub

FixUpdateFile_Error:
  Call Process_Error("FixUpdateFile")
  Resume FixUpdateFile_Done

End Sub

