Attribute VB_Name = "Module2"
Option Explicit

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
    (ByVal hkey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
    ByVal samDesired As Long, phkResult As Long) As Long
Public Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpName As String, _
    lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, _
    lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
    (ByVal mKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
    lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hkey As Long) As Long
Public Declare Function RegEnumValueType Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, _
    ByVal null1 As Long, ByVal null2 As Long) As Long
Public Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, _
    lpcbData As Long) As Long
Public Declare Function RegEnumValueString Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hkey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
    lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As String, _
    lpcbData As Long) As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006
Public Const ERR_MORE_DATA = 234
' Reg key security attribute
Public Const KEY_QUERY_VALUE = &H1&
Public Const KEY_SET_VALUE = &H2&
Public Const KEY_ALL_ACCESS = &H3F
Public Const KEY_CREATE_SUBKEY = &H4&
Public Const KEY_ENUMERATE_SUBKEY = &H8&
Public Const KEY_NOTIFY = &H10&
Public Const KEY_CREATE_LINK = &H20
Public Const READ_CONTROL = &H20000
Public Const WRITE_OWNER = &H80000
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const STANDARD_RIGHTS_READ = READ_CONTROL
Public Const STANDARD_RIGHTS_WRITE = READ_CONTROL
Public Const STANDARD_RIGHTS_EXECUTE = READ_CONTROL
Public Const KEY_READ = STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or _
      KEY_ENUMERATE_SUBKEY Or KEY_NOTIFY
Public Const KEY_WRITE = STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUBKEY

Public Const REG_NONE = 0
Public Const REG_SZ = 1                 ' Unicode null terminated string
Public Const REG_EXPAND_SZ = 2
Public Const REG_BINARY = 3             ' Binary
Public Const REG_DWORD = 4              ' 32-bit number
Public Const REG_DWORD_LITTLE_ENDIAN = 4
Public Const REG_DWORD_BIG_ENDIAN = 5
Public Const REG_LINK = 6
Public Const REG_MULTI_SZ = 7
Public Const REG_RESOURCE_LIST = 8
Public Const REG_FULL_RESOURCE_DESCRIPTOR = 9
Public Const REG_RESOURCE_REQUIREMENTS_LIST = 10

Global mMainKey As Long
Global mIndent As Integer
Global mStopFlag As Boolean
Global mAccumText As String                 ' To avoid blinks (if changing Text1 every time)
Global mResult As Long











Public Function GetMainKey(ByVal inName As String) As Long
    GetMainKey = 0
    If inName = "HKEY_CLASSES_ROOT" Then
        GetMainKey = HKEY_CLASSES_ROOT
    ElseIf inName = "HKEY_CURRENT_USER" Then
        GetMainKey = HKEY_CURRENT_USER
    ElseIf inName = "HKEY_LOCAL_MACHINE" Then
        GetMainKey = HKEY_LOCAL_MACHINE
    ElseIf inName = "HKEY_USERS" Then
        GetMainKey = HKEY_USERS
    ElseIf inName = "HKEY_PERFORMANCE_DATA" Then
        GetMainKey = HKEY_PERFORMANCE_DATA
    ElseIf inName = "HKEY_CURRENT_CONFIG" Then
        GetMainKey = HKEY_CURRENT_CONFIG
    ElseIf inName = "HKEY_DYN_DATA" Then
        GetMainKey = HKEY_CURRENT_CONFIG
    End If
End Function

Public Function GetMainKeyString(ByVal MainKey As Long) As String
Select Case MainKey

Case HKEY_CLASSES_ROOT
        GetMainKeyString = "HKEY_CLASSES_ROOT"
 Case HKEY_CURRENT_USER
        GetMainKeyString = "HKEY_CURRENT_USER"
 Case HKEY_LOCAL_MACHINE
        GetMainKeyString = "HKEY_LOCAL_MACHINE"
Case HKEY_USERS
        GetMainKeyString = "HKEY_USERS"
 Case HKEY_PERFORMANCE_DATA
        GetMainKeyString = "HKEY_PERFORMANCE_DATA"
 Case HKEY_CURRENT_CONFIG
        GetMainKeyString = "HKEY_CURRENT_CONFIG"
 Case HKEY_DYN_DATA
        GetMainKeyString = "HKEY_CURRENT_CONFIG"
  End Select
        
End Function


Public Function DoEnumSubKeys(ByVal inMainKey As Long, ByVal inSubKey As String)
    Dim mKey As Long
    Dim colSubKeys As Collection
    Dim mBuffer As String * 256
    Dim mBufSize As Long
    Dim mClassBuffer As String * 256
    Dim mClassBufSize As Long
    Dim typLastWriteTime As FILETIME
    
    Dim mSubKeyName As String
    Dim mSubKeyValue As String
    Dim mValType As Long
    Dim mIndex As Integer
    Dim i As Integer

    Set colSubKeys = New Collection
    If RegOpenKeyEx(inMainKey, inSubKey, 0&, KEY_ALL_ACCESS, mKey) <> 0 Then
        MsgBox "Unable to open a subkey"
        Exit Function
    End If

    ListEntryValues inMainKey, inSubKey
    
       ' The above list the current subkey and its own entries and values

       '===================================================================
       ' Enumerate the Subkey's colSubKeys
    mIndex = 0
    Do
         ' lpClassBuffer is a pointer to a buffer that receives the null-terminated
         ' class string of the enumerated subkey. No classes are currently defined;
         ' hence this parameter can be NULL.
         ' lpClassBufSize is a pointer to a variable that specifies the size of
         ' lpClassBuffer, including the terminating null character. When the function
         ' returns, it contains the number of characters stored in the buffer.
         ' The count returned does not include the terminating null character.
        
        mClassBuffer = ""
        mClassBufSize = 0
        mBufSize = 256
        mSubKeyName = Space$(mBufSize)
        
        mResult = RegEnumKeyEx(mKey, mIndex, mSubKeyName, mBufSize, 0, mClassBuffer, _
                mClassBufSize, typLastWriteTime)
        If mResult <> ERR_MORE_DATA And mResult <> 0 Then
             'MsgBox APIErrorDescription(mResult)
             Exit Do
        End If
        
        mSubKeyName = Left$(mSubKeyName, InStr(mSubKeyName, Chr$(0)) - 1)
        colSubKeys.Add mSubKeyName
        mIndex = mIndex + 1
    Loop
    
    RegCloseKey mKey
    
    If mIndex > 0 Then
        mIndent = mIndent + 3
    Else
        mIndent = 3
    End If
       
       ' Recursively get information on the keys.
    For i = 1 To colSubKeys.Count
        DoEvents
          ' Registry is a huge database; in case user input is a big subkey,
          ' we don't want to wait for too long.  Hence set a limit here.
        'If Len(mAccumText) > Val(frmRegEnum.txtLimitLength.Text) Then
           ' mAccumText = mAccumText & "......(more) ......." & vbCrLf
            'mStopFlag = True     ' To spin off the loop of "For mIndex = 1 To colSubKeys.Count"
            'Exit For
        'End If
        If mStopFlag Then
             Exit For
        End If
        DoEnumSubKeys inMainKey, inSubKey & "\" & colSubKeys(i)
    Next i
End Function

Public Function ListEntryValues(ByVal inMainKey As Long, ByVal inSubKey As String)
    Dim mKey As Long
    Dim mIndex As Long
    Dim mReturnEntry, lKey As String
    Dim mEntry As String
    Dim mEntryLength As Long
    Dim mDataType As Long
    Dim arrDataByte(1 To 1024) As Byte
    Dim mDataByteLength As Long
    Dim mDataByteValue, sTemp As String
    Dim i As Integer
    Dim j
    Dim y
    Dim tmp As String, mChr As String
    Dim mAlignPos, mAlignPos0, mAlignPos1
    
    
    
    mResult = RegOpenKeyEx(inMainKey, inSubKey, 0&, KEY_ALL_ACCESS, mKey)
    If mResult <> 0 Then
        MsgBox "Error RegOpenKeyEx for " & inSubKey
        Exit Function
    End If
    
     '-----------------------------
    tmp = ""
    'For i = Len(inSubKey) To 1 Step -1
        'mChr = Mid(inSubKey, i, 1)
        'If mChr = "\" Then
           ' Exit For
        'End If
        'tmp = mChr & tmp
   ' Next i
  

    lKey = "[" & GetMainKeyString(inMainKey) & "\" & inSubKey & "]"

      ' Display subkey (without its parent) and its own entries (& values),
      ' at a position of mIndent
    mAccumText = mAccumText & lKey & tmp & vbNewLine
    
    mAlignPos0 = 5
    mAlignPos1 = mAlignPos0 + mIndent + Len(tmp)
   
    
    'If frmRegEnum.Check1.Value = vbChecked Then                ' Display subkey(s) only
             ' Next line for another subkey
          'mAccumText = mAccumText & vbCrLf
          'Exit Function
   'End If
    
    mIndex = 0
    Do
        If mIndex = 0 Then
             mAlignPos = mAlignPos0
        Else
             mAlignPos = mAlignPos1
        End If
    
        mEntryLength = 1024
        mDataByteLength = 1024
        mEntry = Space$(mEntryLength)
        mResult = RegEnumValue(mKey, mIndex, mEntry, mEntryLength, 0, _
             mDataType, arrDataByte(1), mDataByteLength)
        If mResult <> 0 Then                  ' No more
             Exit Do
        End If

        mEntry = Left$(mEntry, mEntryLength)
        
          ' Note if value is "(No value set)" then the following
          ' will not be display, i.e. as if no entry exists.
        If mEntry = "" And mDataByteLength > 0 Then
             mEntry = Chr(64)
             Else
             mEntry = Chr(34) & mEntry & Chr(34)
        End If

        mDataByteValue = ""
        
        Select Case mDataType
        
        
            Case REG_SZ
                For i = 1 To mDataByteLength - 1
                    mDataByteValue = mDataByteValue & Chr$(arrDataByte(i))
                Next i
                    
                    
                mAccumText = mAccumText & mEntry & "=" & Chr(34) & mDataByteValue & Chr(34) & vbCrLf
   
                     
            Case REG_DWORD
                   ' For display in original format as in registry
                tmp = ""
                For i = 4 To 1 Step -1
                     mChr = Hex(Asc(Chr(arrDataByte(i))))
                     If Len(mChr) = 1 Then
                          mChr = "0" + mChr
                     End If
                     tmp = tmp & mChr
                Next
                   ' For display of actual value in decimal as in registry
                y = 0
                For i = 1 To Len(tmp) Step 2
                     mChr = Mid(tmp, i, 2)
                     mChr = ConvNum(mChr, 16, 10)
                     
                     j = Val(mChr)
                     Select Case i
                         Case 1
                             j = j * &H1000000         ' 16777216
                         Case 2
                             j = j * &H10000           ' 65536
                         Case 3
                             j = j * &H100             ' 256
                     End Select
                     y = y + j
                Next
                mDataByteValue = CStr(y)
                
                
             
               
               sTemp = "dword:" & tmp
                
                
                
                mAccumText = mAccumText & mEntry & "=" & sTemp & vbCrLf
               
      
                    
                    
            Case REG_BINARY
                For i = 1 To mDataByteLength
                     mChr = Hex$(Asc(Chr(arrDataByte(i))))
                     If Len(mChr) = 1 Then
                          mChr = "0" & mChr
                     End If
                     mDataByteValue = mDataByteValue & mChr & " "
                Next
                
                sTemp = "hex:" & mDataByteValue
                
                mAccumText = mAccumText & mEntry & "=" & sTemp & vbCrLf
                     
                     
      
                     
            Case Else
            For i = 1 To mDataByteLength - 1
                    mDataByteValue = mDataByteValue & Chr$(arrDataByte(i))
                Next i
                    
                    
                mAccumText = mAccumText & mEntry & "=" & Chr(34) & mDataByteValue & Chr(34) & vbCrLf
   
        End Select
        mIndex = mIndex + 1
    Loop
    
      ' Next line for another subkey
    mAccumText = mAccumText & vbCrLf
End Function




Public Function ConvNum(inNum As String, inFrom As Integer, inTo As Integer) As String
    Dim mChr As String
    Dim i As Integer, j As Integer, k As Integer
    Dim mTotal As Double, mMod As Double, tmp As Double
    ConvNum = ""
    If inNum = "" Then
         Exit Function
    ElseIf inFrom < 2 Or inFrom > 36 Then
         Exit Function
    ElseIf inTo < 1 Or inTo > 36 Then
         Exit Function
    End If
       ' Convert to decimal
    inNum = UCase$(inNum)
    k = Len(inNum)
    For i = 1 To Len(inNum)
         k = k - 1
         mChr = Mid$(inNum, i, 1)
         j = 0
         If Asc(mChr) > 64 And Asc(mChr) < 91 Then
             j = Asc(mChr) - 55
         End If
         If j = 0 Then
              If Asc(mChr) < 48 Or Asc(mChr) > 57 Then
                  Exit Function
              End If
              j = Val(mChr)
         End If

         If j < 0 Or j > inFrom - 1 Then
              Exit Function
         End If
         mTotal = mTotal + j * (inFrom ^ k)
    Next i
       ' In target base
    Do While mTotal > 0
         tmp = CDbl(inTo)
         mMod = mTotal - (Int(mTotal / tmp) * tmp)
         mTotal = (mTotal - mMod) / inTo
         If mMod >= 10 Then
              mChr = Chr$(mMod + 55)
         Else
              mChr = Right$(Str$(mMod), Len(Str$(mMod)) - 1)
         End If
         ConvNum = mChr & ConvNum
    Loop
    If ConvNum = "" Then
         ConvNum = "0"
    End If
End Function






