VERSION 5.00
Begin VB.Form frmHSDemo 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "High Scores Demo"
   ClientHeight    =   2520
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2520
   ScaleWidth      =   4590
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdView 
      Caption         =   "&View High Scores"
      Height          =   375
      Left            =   600
      TabIndex        =   4
      Top             =   360
      Width           =   3375
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear High Score Data From Registry"
      Enabled         =   0   'False
      Height          =   375
      Left            =   600
      TabIndex        =   3
      Top             =   1800
      Width           =   3375
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "&Test"
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      Top             =   1200
      Width           =   855
   End
   Begin VB.TextBox txtScore 
      Height          =   375
      Left            =   600
      MaxLength       =   15
      TabIndex        =   0
      Top             =   1200
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "Enter a score and press ""Test""..."
      Height          =   255
      Left            =   600
      TabIndex        =   2
      Top             =   960
      Width           =   3375
   End
End
Attribute VB_Name = "frmHSDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Project: HiScoresDemo.vbp
'Form: frmHSDemo.frm
'Author: Foyal S. Carter, Jr.
'E-mail: foyalcarter@mciworld.com
'Purpose:
'This form takes the place of the game
'where the high scores module would be
'used. It allows user entry of test scores
'in order to demonstrate usage of the module.

'Note: Read modHiScores first.

'Controls (settings):
'cmdClear - CommandButton (.Caption = "&Clear High Score Data From Registry")
'cmdTest - CommandButton (.Caption = "&Test")
'cmdView - CommandButton (.Caption = "&View High Scores")
'Label1 - Label (.Caption = ""Enter a score and press Test""")
'txtScore - TextBox (.MaxLength = 15: .Text = "")

Option Explicit


Private Sub cmdClear_Click()
                   
    'clear the registry entries
    ClearHiScores 'in modHiScores
            
    'disable the clear button
    cmdClear.Enabled = False
    
End Sub

Private Sub cmdTest_Click()
    
    'check for valid entry in the Score TextBox
    
    If Not IsNumeric(txtScore) Or _
       Val(txtScore) = 0 Then
            
        'show a message
        MsgBox "Enter a Score First", , "No Score"
        
        'reset focus to Score TextBox
        txtScore.SetFocus
        
        'exit
        Exit Sub
    
    End If
    
    'sub type the score with a Decimal Type number...
    'the Decimal Type is written as integers in binary
    'memory without the rounding errors of Singles or Doubles
    'this allows for better precision when formatting large
    'numbers
    udtCurrScore.HSScore = CDec(txtScore)
    
    'clear the Score TextBox
    txtScore = ""
        
    'check for a new high score
    CheckHiScores 'in modHiScores
    
    'if there was a new high score then
    If boolScoreAdded Then
        
        'show the high scores
        frmHiScores.Show vbModal, Me
        
        'save the high score list
        SaveHiScores 'in modHiScores
        
        'enable the clear button
        cmdClear.Enabled = True
        
    End If
    
End Sub


Private Sub cmdView_Click()
    
    'refresh the high scores array
    LoadHiScores  'in modHiScores
    
    'show the high scores
    frmHiScores.Show vbModal, Me
    
End Sub

Private Sub Form_Activate()
    
    'on activation set focus on the Score TextBox
    txtScore.SetFocus
    
End Sub

Private Sub Form_Load()
    
    'load the high scores
    LoadHiScores 'in modHiScores
    
    'if anything besides defaults loaded
    'that means the registry values are
    'present
    'if so, enable the clear button
    If udtHiScores(9).HSScore > 0 Then
        cmdClear.Enabled = True
    End If
    
End Sub

'--------------------------------------------
'A sub something like this would be included
'in your game to implement modHiScores...

'Private Sub GameOver()
    
    'udtCurrScore.HSScore = CDec(PlayerScore)
    '(where PlayerScore is your score variable)
    
    'check for a new high score
    'CheckHiScores 'in modHiScores
    
    'if there was a new high score then
    'If boolScoreAdded Then
        
        'show the high scores
        'frmHiScores.Show vbModal, Me
        
        'save the high score list
        'SaveHiScores 'in modHiScores
        
        'enable the clear button
        'cmdClear.Enabled = True
        
    'End If
    
'End Sub
'--------------------------------------------
