Attribute VB_Name = "Mail21"
' StealthMail 2.1/RTF (High security version)
' CBC mode E-mail/file encryption program
' Copyright Patterson Programming, 1996-1999
' Contains registered material

' This version implements the LeapFrog2 cipher
' which is NOT compatible with LeapFrog

'WARNING: This is an original work of authorship; however, patents
'         might or might not exist that apply to certain sections.
'         In addition, export from the U.S. of this material
'         may be restricted. The author disclaims any and all
'         liability arising from unauthorized use of this material.


DefInt A-Z
Public Const LeapFrogBlockLen = 8
Public Const Search$ = "ZIP*JPG*JPE*GIF*CAB*ARJ*ARC*LZH*PAK*" & _
                       ".GZ*TAR*ICE*ZOO*HPK*PGP*ENC"

Const LeapFrogRounds% = 8
Const CBC = 1
Public Const BUFFERSIZE = 4096  '* MUST be a multiple of BlockLen *
Const HEADERLEN = 8

Global SourcePath$, OutPutPath$, DrivePath$, DoFile$
Global EncInPath$, EncOutPath$, DecInPath$, DecOutPath$, SetPath$
Global filename$, fileSpec$, process%, CipherMode%, BlockLen%
Global ClipText As String, MemoText As String, MasterPwd(31) As Byte
Global verify%, Ppos%, password(31) As Byte, password2(31) As Byte
Global MasterPwdFlag As Integer, KeyArray() As Byte
Global CryptBuffer() As Byte, BufferPointer&, SelectKey As Integer
Global MemoFlag As Integer, FileCancel As Integer
Global FBR(1 To 16) As Integer, Pre_FBR(1 To 16) As Integer
Global Salt(LeapFrogBlockLen) As Byte, WithSalt%, Backup%
Global FontNameIndex%, FontPointsIndex%, KeyCount As Byte
Global KeysFound As Integer, AvoidVerify As Integer, MsgRet%
Global PwdBusy%, NotFlag%, PwdLocked%, PwdMark As Long

'* these global arrays hold the in/out data for Radix64
'* must include space for padding and EOL characters
Global ch() As Byte  '* ENcoded data buffer *
Global bin() As Byte  '* DEcoded data buffer *

'* these arrays are used by Compress.BAS
Global InBuffer() As Byte, OutBuffer() As Byte
Global DataLen&, CompFlag As Integer

Dim SK(LeapFrogRounds%, LeapFrogBlockLen - 1) As Integer
Dim A1%(255), A2%(255), A3%(255), A4%(255)
Dim A5%(255), A6%(255), A7%(255), A8%(255)
Dim SmallFilesFound%, ReadOnlyFound%
Dim initkey%(0 To 31), k%(0 To 23), LongKey%(0 To 255), ByteNumber&

Dim Sig1 As Long, Sig2 As Long


Sub Main()

    If App.PrevInstance = -1 Then
        MsgBox "Program already running!"
        End
    End If

    '* copyright notice
    Notice.Show 1

    InitFolderPaths

    For i% = 0 To 31: MasterPwd(i%) = 32: Next
    Ppos% = 0

    SelectKey = -1
    CipherMode% = CBC

    Sig1 = &H4F6A12C4
    Sig2 = &H5610FF45

    Open App.Path & "\KeyFile.DAT" For Binary Access _
                                        Read Write As #5
    KeysFound = 0
    If LOF(5) >= 72 Then
        KeysFound = -1
    End If
    Close
    Backup% = 0

    '* main menu
    PwdLocked% = -1
    MainForm.Show

End Sub 'Main


Sub CleanUp()

    Erase CryptBuffer
    Erase SK%, A1%, A2%, A3%, A4%, A5%, A6%, A7%, A8%
    For i% = 0 To 31: password(i%) = 32: Next
    For i% = 0 To 31: MasterPwd(i%) = 32: Next
    For i% = 0 To KeyCount - 1
        For j% = 0 To 71
            KeyArray(j%, i%) = 0
        Next
    Next

End Sub


Sub InitFolderPaths()

    On Local Error GoTo Ignore

    CurPath$ = CurDir$
    If Right$(CurPath$, 1) <> "\" Then
        CurPath$ = CurPath$ + "\"
    End If

    '* defaults
    EncInPath$ = CurPath$
    EncOutPath$ = CurPath$
    DecInPath$ = CurPath$
    DecOutPath$ = CurPath$
    FontNameIndex% = 1
    FontPointsIndex% = 2

    If Dir$(App.Path & "\Folders.DAT") <> "" Then
        fn% = FreeFile
        Open App.Path & "\Folders.DAT" For Input Access Read As fn%
        If LOF(fn%) <> 0 Then
            Input #fn%, EncInPath$
            Input #fn%, EncOutPath$
            Input #fn%, DecInPath$
            Input #fn%, DecOutPath$
            Input #fn%, FontNameIndex%
            Input #fn%, FontPointsIndex%
        End If
    End If
    Close
    Exit Sub

Ignore:
    Resume Next
End Sub


Static Sub DoProcess()

    On Error GoTo error_exit

    '* change mousepointer
    MainForm.Enabled = -1
    MainForm.MousePointer = 11
    DoEvents
    MainForm.Enabled = 0

    ReadOnlyError% = 0
    FoundSmallFiles% = 0
    ReadOnlyFound% = 0

    If process% > 0 Then

        IsFileError% = 0
        fileSpec$ = Dir$(SourcePath$ + DoFile$)
        Open SourcePath$ + fileSpec$ For Binary Access Read As #1
        If IsFileError% Then
            MsgBox1 "Path/File Access Error", 0, "Abort"
            GoTo Abort
        End If

        '* set length of data to process
        DataLen& = LOF(1)

        '* file size must be >= to block size
        If DataLen& < BlockLen% Then
            FoundSmallFiles% = -1
            GoTo SmallFilesExit
        End If

        If process% = 2 Then  '* If Decrypt *
            If Not GetHeader() Then
                MsgBox1 "File is Not StealthMail Encrypted", 0, "Abort"
                GoTo Abort
            End If
        End If

        GetFilename% = 0
        IsFileError% = 0
        If process% = 1 Then  '* If Encrypt *
            fileSpec2$ = DoFile$ & ".ENC"
            If Dir$(OutPutPath$ & fileSpec2$) <> "" Then
                If IsFileError% Then
                    GetFilename% = -1
                    GoTo GetFile
                End If
                Mv% = MsgBox2("Filename Already Exists, Continue?", _
                                                           260, "")
                If MasterPwdFlag = 0 Then GoTo Abort
                If Mv% <> 6 Then
                    GetFilename% = -1
                    GoTo GetFile
                Else
                    IsFileError% = 0
                    Kill (OutPutPath$ + fileSpec2$)
                    If ReadOnlyError% = -1 Then
                        ReadOnlyFound% = -1
                        GoTo ReadOnlyExit
                    ElseIf IsFileError% Then
                        GetFilename% = -1
                        GoTo GetFile
                    End If
                End If
            End If
        End If
        If process% = 2 Then  '* If Decrypt *
            If Right$(DoFile$, 4) = ".ENC" Then
                fileSpec2$ = Left$(DoFile$, Len(DoFile$) - 4)
                If Dir$(OutPutPath$ & fileSpec2$) <> "" Then
                    MsgBox1 "File Already Exists", 0, "Abort"
                    GoTo Abort
                End If
            Else
                GetFilename% = -1
                GoTo GetFile
            End If

            If IsFileError% Then
                GetFilename% = -1
                GoTo GetFile
            End If
        End If
GetFile:
        If GetFilename% Then
            fileSpec2$ = InputBox2$("Please Enter OutPut Filename:")

            If MasterPwdFlag = 0 Then GoTo Abort
            If fileSpec2$ = "" Then
                MsgBox1 "Invalid Filename", 0, "Abort"
                GoTo Abort
            End If
            If Dir$(OutPutPath$ & fileSpec2$) <> "" Then
                MsgBox1 "File Already Exists", 0, "Abort"
                GoTo Abort
            End If
        End If

        If MasterPwdFlag = 0 Then GoTo Abort
        IsFileError% = 0
        Open OutPutPath$ + fileSpec2$ For Binary Access Write As #2
        If IsFileError% Then
            MsgBox1 "Can't Use That Filename", 0, "Abort"
            GoTo Abort
        End If

        LockPwd
        Select Case process%
            Case 1
                EncryptFileCBC
            Case 2
                DecryptFileCBC
         End Select

        filesProcessed% = filesProcessed% + 1

        previousFile$ = SourcePath$ + DoFile$
        previousProcess% = process%

        UnlockPwd

ReadOnlyExit:

        If ReadOnlyFound% = -1 Then
            Beep
            MsgBox1 "Read-Only Target File", 0, "Abort"
            GoTo Abort
        End If

SmallFilesExit:

        If FoundSmallFiles% = -1 Then
            Beep
            MsgBox1 "File Too Small To Process", 0, "Warning"
            GoTo Abort
        End If

        MsgBox1 "File Processed OK", 0, "Report"
        filename$ = ""

Abort:
        process% = 0
        MainForm.MousePointer = 0
        '* close this file
        Close
        FileForm.FileList.Refresh

    End If  'process > 0

    Exit Sub 'DoProcess

error_exit:

    IsFileError% = -1

    If Err = 75 Then
        '* can't remove Read-Only file
        ReadOnlyError% = -1
        Resume Next

    Else
        Resume Next
    End If

End Sub 'DoProcess


Private Sub EncryptFileCBC()

    On Error GoTo 0

    ReDim SaveSalt(BlockLen% - 1) As Byte

    '* clear the feedback register
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next

    '* calculate variables
    LastFullBuffer& = DataLen& \ BUFFERSIZE
    ShortBufferLen% = DataLen& Mod BUFFERSIZE
    ShortBlockLen% = DataLen& Mod BlockLen%

    '* get Salt from the data
    If DataLen& > 4096 Then
        SaltLen& = 4096
    Else
        SaltLen& = DataLen&
    End If
    ReDim CryptBuffer(SaltLen& - 1)
    Get #1, , CryptBuffer
    GetTS i1%, i2%, i3%, i4%, i5%, i6%
    CryptBuffer(0) = CryptBuffer(0) Xor i1%
    CryptBuffer(1) = CryptBuffer(1) Xor i2%
    GetSalt SaltLen&
    Salt(0) = Salt(0) Xor i1%
    Salt(1) = Salt(1) Xor i2%
    For i% = 0 To (BlockLen% - 1)
        SaveSalt(i%) = Salt(i%)
    Next
    '* use cipher as Hash Function
    ReSalt

    '* re-adjust the read/write buffer
    ReDim CryptBuffer(BUFFERSIZE - 1)
    Seek #1, 1

    WithSalt% = -1
    CryptInit

    For i% = 1 To BlockLen%: FBR(i%) = 0: Next

    If CompFlag Then
        LZCompFile 1, 2
    Else

    '* if there is a boundary condition, do this
    If ShortBufferLen% > 0 And ShortBufferLen% < BlockLen% Then
        LastFullBuffer& = LastFullBuffer& - 1
        ShortBufferLen% = ShortBlockLen% + BUFFERSIZE
    End If

    '* process chunks of data equal to BUFFERSIZE
    NumberOfBlocks% = (BUFFERSIZE \ BlockLen%)
    For BufferNumber& = 1 To LastFullBuffer&
        BufferPointer& = 0
        Get #1, , CryptBuffer
        SelectCipher (NumberOfBlocks%)
        Put #2, , CryptBuffer
    Next

    If ShortBufferLen% > 0 Then

        ReDim CryptBuffer(ShortBufferLen% - 1)
        Get #1, , CryptBuffer
        '* process the last buffer (less shortblock)
        BufferPointer& = 0
        NumberOfBlocks% = (ShortBufferLen% \ BlockLen%)
        SelectCipher (NumberOfBlocks%)

        If ShortBlockLen% > 0 Then
            '* process the shortblock
            BufferPointer& = ShortBufferLen% - BlockLen%
            For i% = 1 To BlockLen%: FBR(i%) = 0: Next
            SelectCipher (1)
        End If

        '* write the shortbuffer
        Put #2, , CryptBuffer

    End If

    End If 'CompFlag

    '* encrypt the Salt (no feedback)
    CryptInit
    For i% = 0 To (BlockLen% - 1)
        CryptBuffer(i%) = SaveSalt(i%)
    Next
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next
    BufferPointer& = 0
    SelectCipher (1)
    For i% = 0 To (BlockLen% - 1)
        Salt(i%) = CryptBuffer(i%)
    Next

    '* write signature and Salt
    PutHeader

    MainForm.Enabled = -1

End Sub


Private Sub DecryptFileCBC()

    On Error GoTo 0

    ReDim SaveFBR(1 To BlockLen%) As Integer

    '* adjust the read/write buffer
    ReDim CryptBuffer(BUFFERSIZE - 1)

    '* decrypt the Salt
    For i% = 0 To (BlockLen% - 1)
        CryptBuffer(i%) = Salt(i%)
    Next
    For i% = 1 To BlockLen%: Pre_FBR(i%) = 0: Next
    BufferPointer& = 0
    CryptInit
    SelectCipher (1)
    For i% = 0 To (BlockLen% - 1)
        Salt(i%) = CryptBuffer(i%)
    Next
    ReSalt

    WithSalt% = -1
    CryptInit

    '* clear the feedback register
    For i% = 1 To BlockLen%: Pre_FBR(i%) = 0: Next

    '* reposition file
    Seek #1, 1
    DataLen& = DataLen& - HEADERLEN - 8

    If CompFlag Then
        LZDecompFile 1, 2
    Else

    '* calculate variables
    LastFullBuffer& = DataLen& \ BUFFERSIZE
    ShortBufferLen% = DataLen& Mod BUFFERSIZE
    ShortBlockLen% = DataLen& Mod BlockLen%

    '* if there is a boundary condition, do this
    If ShortBufferLen% > 0 And ShortBufferLen% < BlockLen% Then
        LastFullBuffer& = LastFullBuffer& - 1
        ShortBufferLen% = ShortBlockLen% + BUFFERSIZE
    End If

    '* process chunks of data equal to BUFFERSIZE
    NumberOfBlocks% = (BUFFERSIZE \ BlockLen%)
    For BufferNumber& = 1 To LastFullBuffer&
        BufferPointer& = 0
        Get #1, , CryptBuffer
        SelectCipher (NumberOfBlocks%)
        Put #2, , CryptBuffer
    Next
    '* clear plaintext
    For i% = 0 To BUFFERSIZE - 1: CryptBuffer(i%) = 0: Next

    If ShortBufferLen% > 0 Then

        ReDim CryptBuffer(ShortBufferLen% - 1)
        Get #1, , CryptBuffer
        '* process the last buffer (adjust shortblock)
        BufferPointer& = 0
        SetShort% = 0
        If ShortBlockLen% > 0 Then SetShort% = 1
        NumberOfBlocks% = (ShortBufferLen% \ BlockLen%) - SetShort%
        SelectCipher (NumberOfBlocks%)

        If ShortBlockLen% > 0 Then
            '* save the FBR and do the two blocks in reverse
            For i% = 1 To BlockLen%: SaveFBR(i%) = Pre_FBR(i%): Next
            For i% = 1 To BlockLen%: Pre_FBR(i%) = 0: Next
            BufferPointer& = ShortBufferLen% - BlockLen%
            SelectCipher (1)

            For i% = 1 To BlockLen%: Pre_FBR(i%) = SaveFBR(i%): Next
            Foffset% = BlockLen% + ShortBlockLen%
            BufferPointer& = ShortBufferLen% - Foffset%
            SelectCipher (1)
        End If

        '* write the shortbuffer
        Put #2, , CryptBuffer
        '* clear plaintext
        For i% = 0 To ShortBufferLen% - 1: CryptBuffer(i%) = 0: Next

    End If

    End If 'CompFlag

    MainForm.Enabled = -1

End Sub


Sub CryptInit()

    Select Case process%
        Case 1
            BlockLen% = LeapFrogBlockLen
            LeapFrogExpand
        Case 2
            BlockLen% = LeapFrogBlockLen
            LeapFrogExpand
    End Select

End Sub


Sub SelectCipher(LastBlock%)

    Select Case process%
        Case 1
            LeapFrogEncipher (LastBlock%)
        Case 2
            LeapFrogDecipher (LastBlock%)

        '* more ciphers may be added here
    End Select

End Sub


Private Sub LeapFrogEncipher(LastBlock%)

    Dim T1 As Integer, T2 As Integer, T3 As Integer, T4 As Integer

    For BlockNumber% = 0 To LastBlock% - 1

        p1% = CryptBuffer(BufferPointer&)
        p2% = CryptBuffer(BufferPointer& + 1)
        p3% = CryptBuffer(BufferPointer& + 2)
        p4% = CryptBuffer(BufferPointer& + 3)
        p5% = CryptBuffer(BufferPointer& + 4)
        p6% = CryptBuffer(BufferPointer& + 5)
        p7% = CryptBuffer(BufferPointer& + 6)
        p8% = CryptBuffer(BufferPointer& + 7)

        If CipherMode% = CBC Then
            p1% = p1% Xor FBR(1)
            p2% = p2% Xor FBR(2)
            p3% = p3% Xor FBR(3)
            p4% = p4% Xor FBR(4)
            p5% = p5% Xor FBR(5)
            p6% = p6% Xor FBR(6)
            p7% = p7% Xor FBR(7)
            p8% = p8% Xor FBR(8)
        End If

        For x% = 0 To (LeapFrogRounds% \ 2) - 1

            '* create the T variables
            T1 = A1%(p1% Xor SK(x%, 0))
            T2 = A2%(p2% Xor SK(x%, 1))
            T3 = A3%(p3% Xor SK(x%, 2))
            T4 = A4%(p4% Xor SK(x%, 3))

            '* T variable order "A"
            p5% = p5% Xor A1%(A1%(T2 Xor T3) Xor T4)
            p6% = p6% Xor A2%(A2%(T1 Xor T4) Xor T3)
            p7% = p7% Xor A3%(A3%(T4 Xor T2) Xor T1)
            p8% = p8% Xor A4%(A4%(T3 Xor T1) Xor T2)
            p5% = (p5% + T1) And &HFF
            p6% = (p6% + T2) And &HFF
            p7% = (p7% + T3) And &HFF
            p8% = (p8% + T4) And &HFF

            '* do other half without swapping
            T1 = A5%(p5% Xor SK(x%, 4))
            T2 = A6%(p6% Xor SK(x%, 5))
            T3 = A7%(p7% Xor SK(x%, 6))
            T4 = A8%(p8% Xor SK(x%, 7))

            p1% = p1% Xor A5%(A5%(T2 Xor T3) Xor T4)
            p2% = p2% Xor A6%(A6%(T1 Xor T4) Xor T3)
            p3% = p3% Xor A7%(A7%(T4 Xor T2) Xor T1)
            p4% = p4% Xor A8%(A8%(T3 Xor T1) Xor T2)
            p1% = (p1% + T1) And &HFF
            p2% = (p2% + T2) And &HFF
            p3% = (p3% + T3) And &HFF
            p4% = (p4% + T4) And &HFF

        Next

        For x% = (LeapFrogRounds% \ 2) To (LeapFrogRounds% - 1)

            '* create the T variables
            T1 = A1%(p1% Xor SK(x%, 0))
            T2 = A2%(p2% Xor SK(x%, 1))
            T3 = A3%(p3% Xor SK(x%, 2))
            T4 = A4%(p4% Xor SK(x%, 3))

            '* T variable order "B"
            p5% = p5% Xor A1%(A1%(T2 Xor T3) Xor T4)
            p6% = p6% Xor A2%(A2%(T3 Xor T4) Xor T1)
            p7% = p7% Xor A3%(A3%(T4 Xor T1) Xor T2)
            p8% = p8% Xor A4%(A4%(T1 Xor T2) Xor T3)
            p5% = (p5% + T1) And &HFF
            p6% = (p6% + T2) And &HFF
            p7% = (p7% + T3) And &HFF
            p8% = (p8% + T4) And &HFF

            '* do other half without swapping
            T1 = A5%(p5% Xor SK(x%, 4))
            T2 = A6%(p6% Xor SK(x%, 5))
            T3 = A7%(p7% Xor SK(x%, 6))
            T4 = A8%(p8% Xor SK(x%, 7))

            p1% = p1% Xor A5%(A5%(T2 Xor T3) Xor T4)
            p2% = p2% Xor A6%(A6%(T3 Xor T4) Xor T1)
            p3% = p3% Xor A7%(A7%(T4 Xor T1) Xor T2)
            p4% = p4% Xor A8%(A8%(T1 Xor T2) Xor T3)
            p1% = (p1% + T1) And &HFF
            p2% = (p2% + T2) And &HFF
            p3% = (p3% + T3) And &HFF
            p4% = (p4% + T4) And &HFF

        Next

        '* whiten data
        p1% = p1% Xor SK(LeapFrogRounds%, 0)
        p2% = p2% Xor SK(LeapFrogRounds%, 1)
        p3% = p3% Xor SK(LeapFrogRounds%, 2)
        p4% = p4% Xor SK(LeapFrogRounds%, 3)

        p5% = p5% Xor SK(LeapFrogRounds%, 4)
        p6% = p6% Xor SK(LeapFrogRounds%, 5)
        p7% = p7% Xor SK(LeapFrogRounds%, 6)
        p8% = p8% Xor SK(LeapFrogRounds%, 7)

        '* write cipher text
        CryptBuffer(BufferPointer&) = p1%
        CryptBuffer(BufferPointer& + 1) = p2%
        CryptBuffer(BufferPointer& + 2) = p3%
        CryptBuffer(BufferPointer& + 3) = p4%
        CryptBuffer(BufferPointer& + 4) = p5%
        CryptBuffer(BufferPointer& + 5) = p6%
        CryptBuffer(BufferPointer& + 6) = p7%
        CryptBuffer(BufferPointer& + 7) = p8%

        FBR(1) = p1%
        FBR(2) = p2%
        FBR(3) = p3%
        FBR(4) = p4%
        FBR(5) = p5%
        FBR(6) = p6%
        FBR(7) = p7%
        FBR(8) = p8%

        BufferPointer& = BufferPointer& + 8
        ByteNumber& = ByteNumber& + 8

    Next

End Sub


Private Sub LeapFrogDecipher(LastBlock%)

    Dim T1 As Integer, T2 As Integer, T3 As Integer, T4 As Integer

    For BlockNumber% = 0 To LastBlock% - 1

        p1% = CryptBuffer(BufferPointer&)
        p2% = CryptBuffer(BufferPointer& + 1)
        p3% = CryptBuffer(BufferPointer& + 2)
        p4% = CryptBuffer(BufferPointer& + 3)
        p5% = CryptBuffer(BufferPointer& + 4)
        p6% = CryptBuffer(BufferPointer& + 5)
        p7% = CryptBuffer(BufferPointer& + 6)
        p8% = CryptBuffer(BufferPointer& + 7)

        FBR(1) = p1%
        FBR(2) = p2%
        FBR(3) = p3%
        FBR(4) = p4%
        FBR(5) = p5%
        FBR(6) = p6%
        FBR(7) = p7%
        FBR(8) = p8%

        '* unwhiten data
        p1% = p1% Xor SK(LeapFrogRounds%, 0)
        p2% = p2% Xor SK(LeapFrogRounds%, 1)
        p3% = p3% Xor SK(LeapFrogRounds%, 2)
        p4% = p4% Xor SK(LeapFrogRounds%, 3)

        p5% = p5% Xor SK(LeapFrogRounds%, 4)
        p6% = p6% Xor SK(LeapFrogRounds%, 5)
        p7% = p7% Xor SK(LeapFrogRounds%, 6)
        p8% = p8% Xor SK(LeapFrogRounds%, 7)

        For y% = 0 To (LeapFrogRounds% \ 2) - 1

            '* invert subkeys
            x% = (LeapFrogRounds% - 1) - y%

            '* create the T variables
            T1 = A5%(p5% Xor SK(x%, 4))
            T2 = A6%(p6% Xor SK(x%, 5))
            T3 = A7%(p7% Xor SK(x%, 6))
            T4 = A8%(p8% Xor SK(x%, 7))

           '* T variable order "B"
            p1% = (p1% - T1) And &HFF
            p2% = (p2% - T2) And &HFF
            p3% = (p3% - T3) And &HFF
            p4% = (p4% - T4) And &HFF
            p1% = p1% Xor A5%(A5%(T2 Xor T3) Xor T4)
            p2% = p2% Xor A6%(A6%(T3 Xor T4) Xor T1)
            p3% = p3% Xor A7%(A7%(T4 Xor T1) Xor T2)
            p4% = p4% Xor A8%(A8%(T1 Xor T2) Xor T3)

            '* do other half without swapping
            T1 = A1%(p1% Xor SK(x%, 0))
            T2 = A2%(p2% Xor SK(x%, 1))
            T3 = A3%(p3% Xor SK(x%, 2))
            T4 = A4%(p4% Xor SK(x%, 3))

            p5% = (p5% - T1) And &HFF
            p6% = (p6% - T2) And &HFF
            p7% = (p7% - T3) And &HFF
            p8% = (p8% - T4) And &HFF
            p5% = p5% Xor A1%(A1%(T2 Xor T3) Xor T4)
            p6% = p6% Xor A2%(A2%(T3 Xor T4) Xor T1)
            p7% = p7% Xor A3%(A3%(T4 Xor T1) Xor T2)
            p8% = p8% Xor A4%(A4%(T1 Xor T2) Xor T3)

        Next

        For y% = (LeapFrogRounds% \ 2) To (LeapFrogRounds% - 1)

            '* invert subkeys
            x% = (LeapFrogRounds% - 1) - y%

            '* create the T variables
            T1 = A5%(p5% Xor SK(x%, 4))
            T2 = A6%(p6% Xor SK(x%, 5))
            T3 = A7%(p7% Xor SK(x%, 6))
            T4 = A8%(p8% Xor SK(x%, 7))

           '* T variable order "A"
            p1% = (p1% - T1) And &HFF
            p2% = (p2% - T2) And &HFF
            p3% = (p3% - T3) And &HFF
            p4% = (p4% - T4) And &HFF
            p1% = p1% Xor A5%(A5%(T2 Xor T3) Xor T4)
            p2% = p2% Xor A6%(A6%(T1 Xor T4) Xor T3)
            p3% = p3% Xor A7%(A7%(T4 Xor T2) Xor T1)
            p4% = p4% Xor A8%(A8%(T3 Xor T1) Xor T2)

            '* do other half without swapping
            T1 = A1%(p1% Xor SK(x%, 0))
            T2 = A2%(p2% Xor SK(x%, 1))
            T3 = A3%(p3% Xor SK(x%, 2))
            T4 = A4%(p4% Xor SK(x%, 3))

            p5% = (p5% - T1) And &HFF
            p6% = (p6% - T2) And &HFF
            p7% = (p7% - T3) And &HFF
            p8% = (p8% - T4) And &HFF
            p5% = p5% Xor A1%(A1%(T2 Xor T3) Xor T4)
            p6% = p6% Xor A2%(A2%(T1 Xor T4) Xor T3)
            p7% = p7% Xor A3%(A3%(T4 Xor T2) Xor T1)
            p8% = p8% Xor A4%(A4%(T3 Xor T1) Xor T2)

        Next

        If CipherMode% = CBC Then
            p1% = p1% Xor Pre_FBR(1)
            p2% = p2% Xor Pre_FBR(2)
            p3% = p3% Xor Pre_FBR(3)
            p4% = p4% Xor Pre_FBR(4)
            p5% = p5% Xor Pre_FBR(5)
            p6% = p6% Xor Pre_FBR(6)
            p7% = p7% Xor Pre_FBR(7)
            p8% = p8% Xor Pre_FBR(8)
        End If

        Pre_FBR(1) = FBR(1)
        Pre_FBR(2) = FBR(2)
        Pre_FBR(3) = FBR(3)
        Pre_FBR(4) = FBR(4)
        Pre_FBR(5) = FBR(5)
        Pre_FBR(6) = FBR(6)
        Pre_FBR(7) = FBR(7)
        Pre_FBR(8) = FBR(8)

        '* write plain text
        CryptBuffer(BufferPointer&) = p1%
        CryptBuffer(BufferPointer& + 1) = p2%
        CryptBuffer(BufferPointer& + 2) = p3%
        CryptBuffer(BufferPointer& + 3) = p4%
        CryptBuffer(BufferPointer& + 4) = p5%
        CryptBuffer(BufferPointer& + 5) = p6%
        CryptBuffer(BufferPointer& + 6) = p7%
        CryptBuffer(BufferPointer& + 7) = p8%

        BufferPointer& = BufferPointer& + 8
        ByteNumber& = ByteNumber& + 8

    Next

End Sub


Private Sub LeapFrogExpand()

    PackPassword
    For i% = 0 To 23
        If k%(23 - i%) <> 0 Then Exit For
    Next
    RealKeyLen% = 24 - i%
    UserKeyLen% = RealKeyLen%

    If WithSalt% Then RealKeyLen% = RealKeyLen% + BlockLen%

    '* replicate key into array
    y% = 0
    For x% = 0 To 255

    '* if Salt is TRUE then append CBC-MAC to real key
        If WithSalt% Then
            If y% > (UserKeyLen% - 1) Then
                LongKey%(x%) = Salt(SaltIndex%)
                SaltIndex% = (SaltIndex% + 1) Mod BlockLen%
            Else
                LongKey%(x%) = k%(y%)
            End If
        Else
            LongKey%(x%) = k%(y%)
        End If

        y% = (y% + 1) Mod RealKeyLen%
    Next

    '* initialize expanded key arrays
    For i% = 0 To 255
        A1%(i%) = i%: A5%(i%) = i%
        A2%(i%) = i%: A6%(i%) = i%
        A3%(i%) = i%: A7%(i%) = i%
        A4%(i%) = i%: A8%(i%) = i%
    Next

    j% = 0
    '* randomize array
    For i% = 0 To 255
        j% = (j% + A1%(i%) + LongKey%(i%)) And &HFF
        SWAP A1%(i%), A1%(j%)
    Next
    For i% = 0 To 255
        j% = (j% + A1%(i%)) And &HFF: SWAP A1%(i%), A1%(j%)
    Next

    '* randomize the other arrays
    For i% = 0 To 255
        j% = (j% + A1%(A2%(i%)) + A1%(LongKey%(i%))) And &HFF
        SWAP A2%(i%), A2%(j%)
    Next
    For i% = 0 To 255
        j% = (j% + A2%(A3%(i%)) + A2%(LongKey%(i%))) And &HFF
        SWAP A3%(i%), A3%(j%)
    Next
    For i% = 0 To 255
        j% = (j% + A3%(A4%(i%)) + A3%(LongKey%(i%))) And &HFF
        SWAP A4%(i%), A4%(j%)
    Next

    For i% = 0 To 255
        j% = (j% + A4%(A5%(i%)) + A4%(LongKey%(i%))) And &HFF
        SWAP A5%(i%), A5%(j%)
    Next
    For i% = 0 To 255
        j% = (j% + A5%(A6%(i%)) + A5%(LongKey%(i%))) And &HFF
        SWAP A6%(i%), A6%(j%)
    Next
    For i% = 0 To 255
        j% = (j% + A6%(A7%(i%)) + A6%(LongKey%(i%))) And &HFF
        SWAP A7%(i%), A7%(j%)
    Next
    For i% = 0 To 255
        j% = (j% + A7%(A8%(i%)) + A7%(LongKey%(i%))) And &HFF
        SWAP A8%(i%), A8%(j%)
    Next

    '* make subkeys from S-boxes
    Erase SK
    For i% = 0 To 63
        SK(0, 0) = (SK(0, 0) + A1%(i%)) And &HFF
        SK(0, 1) = (SK(0, 1) + A2%(i%)) And &HFF
        SK(0, 2) = (SK(0, 2) + A3%(i%)) And &HFF
        SK(0, 3) = (SK(0, 3) + A4%(i%)) And &HFF
        SK(0, 4) = (SK(0, 4) + A5%(i%)) And &HFF
        SK(0, 5) = (SK(0, 5) + A6%(i%)) And &HFF
        SK(0, 6) = (SK(0, 6) + A7%(i%)) And &HFF
        SK(0, 7) = (SK(0, 7) + A8%(i%)) And &HFF
    Next
    For i% = 0 To LeapFrogRounds% - 1
        SK(i% + 1, 0) = (SK(i%, 0) + A1%(64 + i%)) And &HFF
        SK(i% + 1, 1) = (SK(i%, 1) + A2%(64 + i%)) And &HFF
        SK(i% + 1, 2) = (SK(i%, 2) + A3%(64 + i%)) And &HFF
        SK(i% + 1, 3) = (SK(i%, 3) + A4%(64 + i%)) And &HFF
        SK(i% + 1, 4) = (SK(i%, 4) + A5%(64 + i%)) And &HFF
        SK(i% + 1, 5) = (SK(i%, 5) + A6%(64 + i%)) And &HFF
        SK(i% + 1, 6) = (SK(i%, 6) + A7%(64 + i%)) And &HFF
        SK(i% + 1, 7) = (SK(i%, 7) + A8%(64 + i%)) And &HFF
    Next
    For i% = 0 To LeapFrogRounds%
        SK(i%, 0) = A5(SK(i%, 0))
        SK(i%, 1) = A6(SK(i%, 1))
        SK(i%, 2) = A7(SK(i%, 2))
        SK(i%, 3) = A8(SK(i%, 3))
    Next
    For i% = 0 To LeapFrogRounds%
        SK(i%, 4) = A1(SK(i%, 4))
        SK(i%, 5) = A2(SK(i%, 5))
        SK(i%, 6) = A3(SK(i%, 6))
        SK(i%, 7) = A4(SK(i%, 7))
    Next

    '* erase initial key arrays
    Erase initkey%, k%, LongKey%
    '* default to NoSalt
    WithSalt% = 0

End Sub


Sub PackPassword()

  For i% = 0 To 31
      initkey%(i%) = password(i%) - 32
  Next

  '* pack 32 ASCII character password into real 192-bit key (24 bytes)
  k%(0) = initkey%(0) Or ((initkey%(1) And &H3) * 64)
  k%(1) = ((initkey%(1) And &H3C) \ 4) Or ((initkey%(2) And &HF) * 16)
  k%(2) = ((initkey%(2) And &H30) \ 16) Or (initkey%(3) * 4)
  k%(3) = initkey%(4) Or ((initkey%(5) And &H3) * 64)
  k%(4) = ((initkey%(5) And &H3C) \ 4) Or ((initkey%(6) And &HF) * 16)
  k%(5) = ((initkey%(6) And &H30) \ 16) Or (initkey%(7) * 4)
  k%(6) = initkey%(8) Or ((initkey%(9) And &H3) * 64)
  k%(7) = ((initkey%(9) And &H3C) \ 4) Or ((initkey%(10) And &HF) * 16)
  k%(8) = ((initkey%(10) And &H30) \ 16) Or (initkey%(11) * 4)
  k%(9) = initkey%(12) Or ((initkey%(13) And &H3) * 64)
  k%(10) = ((initkey%(13) And &H3C) \ 4) Or ((initkey%(14) And &HF) * 16)
  k%(11) = ((initkey%(14) And &H30) \ 16) Or (initkey%(15) * 4)
  k%(12) = initkey%(16) Or ((initkey%(17) And &H3) * 64)
  k%(13) = ((initkey%(17) And &H3C) \ 4) Or ((initkey%(18) And &HF) * 16)
  k%(14) = ((initkey%(18) And &H30) \ 16) Or (initkey%(19) * 4)
  k%(15) = initkey%(20) Or ((initkey%(21) And &H3) * 64)
  k%(16) = ((initkey%(21) And &H3C) \ 4) Or ((initkey%(22) And &HF) * 16)
  k%(17) = ((initkey%(22) And &H30) \ 16) Or (initkey%(23) * 4)
  k%(18) = initkey%(24) Or ((initkey%(25) And &H3) * 64)
  k%(19) = ((initkey%(25) And &H3C) \ 4) Or ((initkey%(26) And &HF) * 16)
  k%(20) = ((initkey%(26) And &H30) \ 16) Or (initkey%(27) * 4)
  k%(21) = initkey%(28) Or ((initkey%(29) And &H3) * 64)
  k%(22) = ((initkey%(29) And &H3C) \ 4) Or ((initkey%(30) And &HF) * 16)
  k%(23) = ((initkey%(30) And &H30) \ 16) Or (initkey%(31) * 4)

End Sub


Sub EncryptClip()

    ReDim SaveSalt(BlockLen% - 1) As Byte

    '* ClipText As String is GLOBAL

    ClipText = MemoText
    ClipTextLen& = Len(ClipText)
    ChkTextLen& = Len(MemoForm.MemoBox.Text)
    Unload MemoForm
    DoEvents

    If ChkTextLen& > 65535 Then
        MsgBox1 "Message Too Large, Send Graphics as Attachment", 0, ""
        MemoFlag = 0  '* correct the caller *
        Exit Sub
    End If
    If ChkTextLen& = 0 Then
        MsgBox1 "There is no TEXT to Encrypt", 0, ""
        MemoFlag = 0  '* correct the caller *
        Exit Sub
    ElseIf ClipTextLen& < BlockLen% Then
        ClipText = ClipText + Space$(BlockLen% - ClipTextLen&)
        ClipTextLen& = BlockLen%
    End If

    '* get Salt from the data
    If ClipTextLen& > 16384 Then
        SaltLen& = 16384
    Else
        SaltLen& = ClipTextLen&
    End If
    ReDim CryptBuffer(SaltLen& - 1)
    For p& = 0 To SaltLen& - 1
        CryptBuffer(p&) = Asc(Mid$(ClipText, p& + 1, 1))
    Next
    GetSalt SaltLen&
    For i% = 0 To (BlockLen% - 1)
        SaveSalt(i%) = Salt(i%)
    Next
    '* use cipher as Hash Function
    ReSalt

    MaxLen& = (ClipTextLen& + (ClipTextLen& \ 8)) + BlockLen%
    ReDim InBuffer(ClipTextLen& - 1)
    Margin% = BlockLen%
    ReDim OutBuffer(MaxLen& + Margin%)
    For p& = 0 To ClipTextLen& - 1
        InBuffer(p&) = Asc(Mid$(ClipText, p& + 1, 1))
    Next
    CompLen& = 0

    LZCompress ClipTextLen&, CompLen&
    If CompLen& < BlockLen% Then
        p& = CompLen&
        For i% = 0 To (BlockLen% - CompLen&) - 1
            OutBuffer(p& + i%) = 32
        Next
        CompLen& = CompLen& + BlockLen%
    End If

    For p& = 0 To ClipTextLen& - 1: InBuffer(p&) = 0: Next
    Erase InBuffer
    TextPlusIV& = CompLen& + BlockLen%  '* space for IV *
    ReDim CryptBuffer(TextPlusIV& - 1)

    For p& = 0 To CompLen& - 1
        CryptBuffer(p& + BlockLen%) = OutBuffer(p&)
        OutBuffer(p&) = 0
    Next
    Erase OutBuffer

    '* clear the feedback register
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next

    '* create pseudo-IV
    GetTS i1%, i2%, i3%, i4%, i5%, i6%
    GetVector v1%, v2%, v3%
    CryptBuffer(0) = i1%
    CryptBuffer(1) = i2%
    CryptBuffer(2) = i3%
    CryptBuffer(3) = i4%
    CryptBuffer(4) = i5%
    CryptBuffer(5) = i6%

    '* encrypt TS with fixed key
    For i% = 0 To 31: password2(i%) = password(i%): Next
    For i% = 0 To 31: password(i%) = i% + 32: Next
    CryptInit
    Blocks& = 1
    BufferPointer& = 0
    SelectCipher (Blocks&)
    '* clear the feedback register
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next

    '* encrypt result with vector
    CryptBuffer(0) = CryptBuffer(0) Xor v1%
    CryptBuffer(1) = CryptBuffer(1) Xor v2%
    CryptBuffer(2) = CryptBuffer(2) Xor v3%
    CryptBuffer(3) = CryptBuffer(3) Xor v4%
    BufferPointer& = 0
    SelectCipher (Blocks&)

    '* encrypt the data
    For i% = 0 To 31: password(i%) = password2(i%): Next
    For i% = 0 To 31: password2(i%) = 32: Next
    WithSalt% = -1
    CryptInit
    Blocks& = (CompLen& \ BlockLen%)
    BufferPointer& = BlockLen%
    SelectCipher (Blocks&)
    ShortBlockLen% = CompLen& Mod BlockLen%
    If ShortBlockLen% > 0 Then
        '* process the shortblock
        BufferPointer& = TextPlusIV& - BlockLen%
        For i% = 1 To BlockLen%: FBR(i%) = 0: Next
        SelectCipher (1)
    End If

    TextPlusSalt& = TextPlusIV& + BlockLen%
    ReDim bin(TextPlusSalt& + 3)
    For p& = 0 To TextPlusIV& - 1: bin(p&) = CryptBuffer(p&): Next

    '* encrypt the Salt (with feedback)
    CryptInit
    For i% = 0 To (BlockLen% - 1)
        CryptBuffer(i%) = SaveSalt(i%)
    Next
    BufferPointer& = 0
    SelectCipher (1)

    '* append the Encrypted Salt
    p& = TextPlusIV&
    For i% = 0 To BlockLen% - 1
        bin(p&) = CryptBuffer(i%)
        p& = p& + 1
    Next
    Erase CryptBuffer

    '* encode the data
    ReDim ch(((TextPlusSalt& * 4) \ 3) + ((TextPlusSalt& \ 48) * 2) + 5)
    EncodeData TextPlusSalt&, RetLen&

    ClipText = Space$(Len(ClipText))
    ClipText = Space$(RetLen&)
    For p& = 0 To RetLen& - 1
        Mid$(ClipText, p& + 1, 1) = Chr$(ch(p&))
    Next

    Erase ch, bin
    Clipboard.Clear
    Clipboard.SetText ClipText

End Sub


Sub DecryptClip()

    '* ClipText As String is GLOBAL

    ReDim SaveFBR(1 To BlockLen%) As Integer

    '* clear the feedback register
    For i% = 1 To BlockLen%: Pre_FBR(i%) = 0: Next

    ClipText = Clipboard.GetText(vbCFText)

    '* replace the CRLF some programs remove
    If Right$(ClipText, 1) <> Chr$(10) Then
        ClipText = Space$(Len(ClipText))
        ClipText = Space$(Len(ClipText) + 2)
        ClipText = Clipboard.GetText(vbCFText) + Chr$(13) + Chr$(10)
    End If
    ClipTextLen& = Len(ClipText)

    '* if text is less than 1 block + IV & Salt then exit
    If ClipTextLen& < (BlockLen% * 3) Then
        MsgBox1 "There is not enough TEXT to Decrypt!", 0, ""
        Exit Sub
    End If

    '* decode the data
    ReDim ch(ClipTextLen& - 1)
    ReDim bin((ClipTextLen& \ 4) * 3)
    For p& = 0 To ClipTextLen& - 1
        ch(p&) = Asc(Mid$(ClipText, p& + 1, 1))
    Next
    If Not DecodeData(ClipTextLen&, RetLen&) Then
        MsgBox1 "Radix64 Decode Error", 0, "Abort"
        Exit Sub
    End If
    Erase ch

    SaltPointer& = (RetLen& - (BlockLen% - 1)) - 1
    IVPointer& = SaltPointer& - BlockLen%
    For i% = 0 To (BlockLen% - 1)
        Salt(i%) = bin(SaltPointer&)
        SaltPointer& = SaltPointer& + 1
    Next
    For i% = 0 To (BlockLen% - 1)
        Pre_FBR(i% + 1) = bin(IVPointer&)
        IVPointer& = IVPointer& + 1
    Next
    ReDim CryptBuffer(ClipTextLen& - 1)

    '* decrypt the Salt (with feedback)
    CryptInit
    For i% = 0 To (BlockLen% - 1)
        CryptBuffer(i%) = Salt(i%)
    Next
    BufferPointer& = 0
    SelectCipher (1)
    For i% = 0 To (BlockLen% - 1)
        Salt(i%) = CryptBuffer(i%)
    Next
    ReSalt

    '* reclear the feedback register
    For i% = 1 To BlockLen%: Pre_FBR(i%) = 0: Next

    '* adjust for Salt
    RetLen& = RetLen& - BlockLen%
    WithSalt% = -1
    CryptInit

    '* decrypt the data
    For p& = 0 To RetLen& - 1: CryptBuffer(p&) = bin(p&): Next
    Erase bin
    BufferPointer& = 0
    ShortLen% = RetLen& Mod BlockLen%
    If ShortLen% > 0 Then SetShort% = 1 Else SetShort% = 0
    NumberOfBlocks& = RetLen& \ BlockLen% - SetShort%
    SelectCipher (NumberOfBlocks&)

    If ShortLen% > 0 Then
        '* process the blocks in reverse
        For i% = 1 To BlockLen%: SaveFBR(i%) = Pre_FBR(i%): Next
        For i% = 1 To BlockLen%: Pre_FBR(i%) = 0: Next
        BufferPointer& = RetLen& - BlockLen%
        SelectCipher (1)

        For i% = 1 To BlockLen%: Pre_FBR(i%) = SaveFBR(i%): Next
        Foffset% = BlockLen% + ShortLen%
        BufferPointer& = RetLen& - Foffset%
        SelectCipher (1)
    End If

    ReDim InBuffer(RetLen& - 1)
    For p& = 0 To RetLen& - 1
        InBuffer(p&) = CryptBuffer(p& + BlockLen%)
        CryptBuffer(p& + BlockLen%) = 0
    Next

    Erase CryptBuffer
    '* OutBuffer() is allocated on the fly in LZDecompress
    DecompLen& = 0
    LZDecompress (RetLen& - BlockLen%), DecompLen&

    ScanLen& = DecompLen& - 1
    For p& = 0 To ScanLen&
        If OutBuffer(ScanLen& - p&) <> 32 Then Exit For
    Next
    DecompLen& = DecompLen& - p&

    ClipText = Space$(Len(ClipText))
    ClipText = Space$(DecompLen&)
    For p& = 0 To DecompLen& - 1
        Mid$(ClipText, p& + 1, 1) = Chr$(OutBuffer(p&))
    Next
    For p& = 0 To RetLen& - 1: OutBuffer(p&) = 0: Next
    Erase InBuffer, OutBuffer

    MemoText = ClipText

End Sub


Function GetHeader()

    Seek #1, LOF(1) - (HEADERLEN - 1)
    Get #1, , Sig1
    Get #1, , Sig2

    '* simple signature test
    If (Sig1 = &H4F6A12C4) Then
        If (Sig2 = &H5610FF45) Or (Sig2 = &H5610FF46) Then
            GetHeader = -1

            Seek #1, LOF(1) - (HEADERLEN - 1) - BlockLen%
            For i% = 0 To (BlockLen% - 1)
                Get #1, , Salt(i%)
            Next
            If (Sig2 = &H5610FF46) Then
                CompFlag = -1
            Else
                CompFlag = 0
            End If
        End If
    Else
        GetHeader = 0
    End If


End Function


Sub PutHeader()

    For i% = 0 To (BlockLen% - 1)
        Put #2, , Salt(i%)
    Next

    Sig1 = &H4F6A12C4
    If CompFlag Then
        Sig2 = &H5610FF46
    Else
        Sig2 = &H5610FF45
    End If

    Put #2, , Sig1
    Put #2, , Sig2

End Sub


Private Sub GetSalt(SaltLen&)

    SaltBlocks& = SaltLen& \ BlockLen%

    '* clear registers
    For i% = 0 To BlockLen% - 1: Salt(i%) = 0: Next
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next

    '* use a fixed key
    For i% = 0 To 31: password2(i%) = password(i%): Next
    For i% = 0 To 31: password(i%) = i% + 32: Next

    '* encrypt the header data to get CBC-MAC
    CryptInit
    BufferPointer& = 0
    SelectCipher (SaltBlocks&)

    '* save MAC for Salt
    For i% = 1 To BlockLen%: Salt(i% - 1) = FBR(i%): Next
    For i% = 0 To 31: password(i%) = password2(i%): Next

End Sub


Sub ReSalt()

    processX% = process%
    process% = 1
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next
    For i% = 0 To (BlockLen% - 1)
        CryptBuffer(i%) = Salt(i%)
    Next
    BufferPointer& = 0
    WithSalt% = -1
    CryptInit
    SelectCipher (1)
    For i% = 0 To (BlockLen% - 1)
        Salt(i%) = CryptBuffer(i%)
    Next
    For i% = 1 To BlockLen%: FBR(i%) = 0: Next
    process% = processX%

End Sub


'* This code helps prevent residual password traces
Sub NotPassword()

    PwdBusy% = -1

    For i% = 0 To 31
        MasterPwd(i%) = Not MasterPwd(i%)
    Next

    For i% = 0 To 31
        password(i%) = Not password(i%)
    Next

    For i% = 0 To 255: A1%(i%) = Not A1%(i%): Next
    For i% = 0 To 255: A2%(i%) = Not A2%(i%): Next
    For i% = 0 To 255: A3%(i%) = Not A3%(i%): Next
    For i% = 0 To 255: A4%(i%) = Not A4%(i%): Next
    For i% = 0 To 255: A5%(i%) = Not A5%(i%): Next
    For i% = 0 To 255: A6%(i%) = Not A6%(i%): Next
    For i% = 0 To 255: A7%(i%) = Not A7%(i%): Next
    For i% = 0 To 255: A8%(i%) = Not A8%(i%): Next

    For i% = 0 To KeyCount - 1
        For j% = 0 To 71
            KeyArray(j%, i%) = Not KeyArray(j%, i%)
        Next
    Next

    For i% = 0 To LeapFrogRounds%
        For j% = 0 To 7
            SK(i%, j%) = Not SK(i%, j%)
        Next
    Next

    NotFlag% = NotFlag% Xor &HFFFF
    PwdBusy% = 0

End Sub

Sub LockPwd()

    If PwdLocked% Then Exit Sub
    PwdLocked% = -1
    Do
    Loop While PwdBusy%
    If NotFlag% Then
        NotPassword
    End If

End Sub

Sub UnlockPwd()

    If Not PwdLocked% Then Exit Sub
    If MasterPwdFlag = 0 Then Exit Sub
    For i% = 0 To 31: password2(i%) = 0: Next

    PwdMark = Int(Timer)
    PwdLocked% = 0

End Sub
