Attribute VB_Name = "Delimited_Strings"
Function Retrieve(Master As String, _
                  Ndx As Integer, _
                  Marker As String) As String
'Retrieve will return the portion of the string identified by Ndx and Marker.
'   Negative indexes are allowed.  -1 always refers to the string that comes
'   after the last instantiation of Marker....even if the string is null
'
'Retrieve uses the following Functions:
'   Ndx_To_Positive
'   Arrayed_Master

Dim str_Temp() As String, Ret_Val As String, int_Temp As Integer
Dim int_Ndx As Integer

Ret_Val = ""
If Master = "" Then GoTo Xit_Retrieve
If Marker = "" Then GoTo Xit_Retrieve

str_Temp = Arrayed_Master(Master, Marker)

int_Ndx = Ndx_To_Positive(Ndx, UBound(str_Temp))

Ret_Val = str_Temp(int_Ndx)


Xit_Retrieve:
    Retrieve = Ret_Val
End Function
Function InsertField(Master As String, _
                     Ndx As Integer, _
                     Marker As String, _
                     Insrt As String) As String
'Insert will put the substring Insrt into the Ndx(th) position of the passed string
'   Master.  This will effectively increase the count of the fields in Master by One.
'   Note that Insrt is NOT checked for instantiations of Marker.
'Insert uses the following UDF:
'   Arrayed_Master

   Dim Ret_Val As String, str_Temp() As String
   Dim int_Ndx As Integer, int_Temp As Integer
   
   Ret_Val = Master
   If Marker = "" Then GoTo Xit_Insert
   If Ndx = 0 Then GoTo Xit_Insert
   
   If Master = "" Then
      Ret_Val = Insrt
      GoTo Xit_Insert
   End If


   str_Temp = Arrayed_Master(Master, Marker)
   int_Temp = UBound(str_Temp)
   int_Ndx = Ndx_To_Positive(Ndx, int_Temp) - (Ndx < 0)
   
   Select Case int_Ndx
      Case Is = 0
         Ret_Val = Master & Insrt & Marker
      Case Is = 1
         Ret_Val = Insrt & Marker & Master
      Case Else
         Ret_Val = ""
         For i = 1 To int_Ndx - 1
           Ret_Val = Ret_Val & str_Temp(i) & Marker
         Next i
         Ret_Val = Ret_Val & Insrt
         While int_Ndx <= int_Temp
           Ret_Val = Ret_Val & Marker & str_Temp(int_Ndx)
           int_Ndx = int_Ndx + 1
         Wend
      End Select

Xit_Insert:
    Insert = Ret_Val
End Function
Function Delete(Master As String, Ndx As Integer, Marker As String) As String
'This function will delete the Ndx(th) field from Master as defined by Marker.
'   This deletion will include the leading/trailing Marker as needed.  ie: if
'   the Ndx passed is the final field, the last Marker of the string will be deleted
'   in the case of ndx = 1, the first Marker will be deleted.
'Delete uses the following UDF:
'   Arrayed_Master

   Dim str_Temp() As String, Ret_Val As String, int_Ndx As Integer
   Dim int_Temp As Integer, i As Integer
   
   Ret_Val = Master
   If Master = "" Then GoTo Xit_Delete
   If Marker = "" Then GoTo Xit_Delete
   
   str_Temp = Arrayed_Master(Master, Marker)
   int_Temp = UBound(str_Temp)
   int_Ndx = Ndx_To_Positive(Ndx, int_Temp)
   
   If int_Ndx = 0 Then GoTo Xit_Delete
   
   Ret_Val = ""
   If int_Temp = 1 Then GoTo Xit_Delete
   
   i = 1
   While i < int_Ndx
      Ret_Val = Ret_Val & str_Temp(i) & Marker
      i = i + 1
   Wend
   i = int_Ndx + 1
   While i <= int_Temp
      Ret_Val = Ret_Val & str_Temp(i) & Marker
      i = i + 1
   Wend
   
   Ret_Val = Left$(Ret_Val, Len(Ret_Val) - Len(Marker))
   
Xit_Delete:
    Delete = Ret_Val
 End Function
Function LeftExclusive(Master As String, _
                       Ndx As Integer, _
                       Marker As String) As String
'This function is designed to return the left-hand portion of the delimited
'   string Master from item 1 thru item Ndx-1.  This function performs the
'   purpose of Left$ in normal string processing
'LeftExclusive uses the following UDF:
'   Arrayed_Master
'   Ndx_To_Positive



   Dim str_Temp() As String, Ret_Val As String, int_Ndx As Integer
   Dim int_Temp As Integer, i As Integer
   
   Ret_Val = ""
   If Master = "" Then GoTo Xit_LeftExclusive
   If Marker = "" Then GoTo Xit_LeftExclusive
   
   str_Temp = Arrayed_Master(Master, Marker)
   int_Temp = UBound(str_Temp)
   If Ndx > 0 And Abs(Ndx) > int_Temp Then
      Ret_Val = Master
      GoTo Xit_LeftExclusive
   End If
   
   int_Ndx = Ndx_To_Positive(Ndx, int_Temp)

   If int_Ndx <= 1 Then GoTo Xit_LeftExclusive
   

   i = int_Ndx - 1
   Ret_Val = str_Temp(1)
   For int_Temp = 2 To i
      Ret_Val = Ret_Val & Marker & str_Temp(int_Temp)
   Next int_Temp

Xit_LeftExclusive:
    LeftExclusive = Ret_Val
End Function
Function RightExclusive(Master As String, _
                       Ndx As Integer, _
                       Marker As String) As String
'This function is designed to return the Right-hand portion of the delimited
'   string Master from item Ndx+1 thru item N.  It fulfills the role played
'   by Right$ in normal string operations
'RightExclusive uses the following UDF:
'   Arrayed_Master
'   Ndx_To_Positive

   Dim str_Temp() As String, Ret_Val As String, int_Ndx As Integer
   Dim int_Temp As Integer, i As Integer
   
   Ret_Val = Master
   If Master = "" Then GoTo Xit_RightExclusive
   If Marker = "" Then GoTo Xit_RightExclusive
   
   str_Temp = Arrayed_Master(Master, Marker)
   int_Temp = UBound(str_Temp)
   If Ndx < 0 And Abs(Ndx) > int_Temp Then
      Ret_Val = Master
      GoTo Xit_RightExclusive
   End If
   int_Ndx = Ndx_To_Positive(Ndx, int_Temp)

   If int_Ndx = 0 Or int_Ndx = int_Temp Then GoTo Xit_RightExclusive
   Ret_Val = str_Temp(int_Ndx + 1)
   i = int_Ndx + 2
   For int_Ndx = i To int_Temp
      Ret_Val = Ret_Val & Marker & str_Temp(int_Ndx)
   Next int_Ndx

Xit_RightExclusive:
    RightExclusive = Ret_Val
End Function
Function Unique_Character(Master As String, _
                          Optional Marker As String, _
                          Optional MaxChar As String) As String
'This function will return a character(s) guaranteed to no exist in the
'       passed string, thus is elligible for use as a delimiter'
'Default value for Marker is chr$(1) and for MaxChar chr$(253)
'       The function will start at Marker and check thru to MaxChar.  If no single
'       character is found, the process begins again at Marker with two characters,
'       then 3 and so on.
'Specifying Marker and MaxChar will restrict the character selection
        
   Dim Ret_Val As String, str_RetVal As String
   Dim int_Marker As Integer, int_MaxChar As String, str_Master As String
   
   
   int_Marker = 1
   If Marker > "" Then int_Marker = Asc(Marker)
   
   int_MaxChar = 253
   If MaxChar > "" Then int_MaxChar = Asc(MaxChar)
   
   If Len(Master) = 0 Then GoTo Xit_Unique_Character
   str_Master = Master
   
   
   Ret_Val = ""
   str_RetVal = ""
   While str_RetVal = ""
      For i = int_Marker To int_MaxChar
        str_RetVal = Ret_Val & Chr$(i)
        If InStr(str_Master, str_RetVal) = 0 Then
          Ret_Val = str_RetVal
          i = int_MaxChar + 10
        End If
      Next i
      If i = int_MaxChar + 1 Then
         Ret_Val = str_RetVal
         str_RetVal = ""
      End If
   Wend
Xit_Unique_Character:
    Unique_Character = Ret_Val
End Function
Function Arrayed_Master(Master As String, _
                                Marker As String, _
                                Optional MinStrings As Integer) As String()
'This function will return an array of type string that is based on the
'   Master with marker as the delimiter.'
'If Marker is a null string, Master will be returned as an array with each character
'   being a field.  This is primarily to prevent pathologic behavior by the calling
'   program to result in a non-recoverable error.   It also makes sense to me, and is
'   how I would like the function to respond.    So There.
'If MinStrings is non-zero the resultant passed array will have a minimum of
'   MinStrings array positions.  All added array positions will be null.
'NOTE:  The base function (split) will return a zero-based array.  Since the
'   purpose of this set of functions is to allow easy use and modifications, the
'   passed string will be prefaced by Marker to start the array at 1.

  Dim Ret_Val() As String, str_Marker As String

  
  If Master = "" Then GoTo Xit_Arrayed_Master
  
  str_Marker = Marker
  If Marker = "" Then str_Marker = Unique_Character(Master)
  Ret_Val = Split(str_Marker & Master, str_Marker)

Xit_Arrayed_Master:
   Arrayed_Master = Ret_Val
End Function
Function Ndx_To_Positive(Ndx As Integer, NumFields As Integer) As Integer
'Nearly all of the functions within this module allow negative indexes.  This
'   function will translate the negative index to it's positive counterpart
'   A negative ndx > the number of fields is a pathologic case and 0 will be
'   returned.

   Dim Ret_Val As Integer
    
   Ret_Val = 0
   If Abs(Ndx) > NumFields Then GoTo Xit_Ndx_To_Positive
   
   Ret_Val = Ndx
   If Ndx > 0 Then GoTo Xit_Ndx_To_Positive

   Ret_Val = NumFields + Ndx + 1
   
Xit_Ndx_To_Positive:
    Ndx_To_Positive = Ret_Val
End Function
Function NoNulls(Master As String, Marker As String) As String
'   This function will delete all null fields from the passed Master, using
'       Marker as the field delimiter.
'NoNulls uses the following UDF
'   Arrayed_Master

   Dim Ret_Val As String
   Dim str_Temp() As String, int_Temp As Integer, i As Integer
   
   Ret_Val = Master
   If Master = "" Or Marker = "" Then GoTo Xit_NoNulls
   If InStr(Master, Marker) = 0 Then GoTo Xit_NoNulls
   If Left$(Master, Len(Marker)) <> Marker And _
      Right$(Master, Len(Marker)) <> Marker And _
      InStr(Master, Marker & Marker) = 0 Then GoTo Xit_NoNulls
      
   str_Temp = Arrayed_Master(Master, Marker)
   int_Temp = UBound(str_Temp)
   Ret_Val = ""
   For i = 1 To int_Temp
      If str_Temp(i) > "" Then Ret_Val = Ret_Val & str_Temp(i) & Marker
   Next i

Xit_NoNulls:
    NoNulls = Ret_Val
End Function
Function IndexOf(Master As String, _
                 SrchStr As String, _
                 Marker As String, _
                 Optional UseCase As Boolean) As Integer
'This function will return the index of the SrchStr within the Master
'   using Marker as the string delimiter.  The match for srchstr MUST
'   be exact in length.
'   UpperCase and LowerCase will be ignored, unless UseCase is set to True
'IndexOf uses the following UDF
'   Arrayed_Master

     Dim Ret_Val As Integer, str_Master() As String, str_SrchStr As String
     Dim int_Temp0 As Integer, int_Cmpare As Long
          
          
     If UseCase Then
          str_Marker = Marker
          str_SrchStr = SrchStr
          str_Master = Arrayed_Master(Master, Marker)
          int_Cmpare = vbBinaryCompare
     Else
          str_Marker = UCase(Marker)
          str_SrchStr = UCase(SrchStr)
          str_Master = Arrayed_Master(UCase(Master), UCase(Marker))
          int_Cmpare = vbTextCompare
     End If
     
     Ret_Val = 0
     If InStr(1, str_SrchStr, str_Marker, int_Cmpare) Then GoTo Xit_IndexOf
     If InStr(1, Master, str_SrchStr, int_Cmpare) = 0 Then GoTo Xit_IndexOf
     
     int_Temp0 = UBound(str_Master)
     For i = 1 To int_Temp0
         If str_SrchStr = str_Master(i) Then
            Ret_Val = i
            i = int_Temp0
         End If
     Next i

Xit_IndexOf:
    IndexOf = Ret_Val
End Function
Function FieldsNum(Master As String, _
                   Marker As String) As Integer
'Fieldsnum will return the number of fields in a delimited string.
'Fieldsnum uses no User Defined Functions

    Dim Ret_Val As Integer, int_Pos As Integer
    
    Ret_Val = 0
    If Master = "" Or Marker = "" Then GoTo Xit_FieldsNum

    int_Pos = InStr(Master, Marker)
    If int_Pos Then Ret_Val = 1
    
    Do
       Ret_Val = Ret_Val + 1
       int_Pos = InStr(int_Pos + 1, Master, Marker)
    Loop While int_Pos > 0
    
Xit_FieldsNum:
    FieldsNum = Ret_Val
End Function
Function ReplaceField(Master As String, _
                      Ndx As Integer, _
                      Marker As String, _
                      Insrt As String) As String
'Replace will literally replace the Ndx(th) field of Master with the string Insrt.
'   This is a destructive overwrite.  Use Insert to simply add a field.
'Replace uses the Following UDF:
'   Arrayed_Master
'   Ndx_To_Positive

   Dim Ret_Val As String, str_Temp() As String
   Dim int_Ndx As Integer, int_Temp As Integer
   
   Ret_Val = Master
   If Marker = "" Then GoTo Xit_Replace
   If Ndx = 0 Then GoTo Xit_Replace
   If Master = "" Then GoTo Xit_Replace

   
   str_Temp = Arrayed_Master(Master, Marker)
   int_Temp = UBound(str_Temp)
   int_Ndx = Ndx_To_Positive(Ndx, int_Temp)
   
   Select Case int_Ndx
      Case Is = 0
         Ret_Val = Master & Insrt & Marker
      Case Else
          str_Temp(int_Ndx) = Insrt
          int_Ndx = UBound(str_Temp)
          Ret_Val = ""
          For i = 1 To int_Ndx
             Ret_Val = Ret_Val & str_Temp(i) & Marker
          Next i
          Ret_Val = Delete(Ret_Val, -1, Marker)
      End Select

Xit_Replace:
    Replace = Ret_Val
End Function
