VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSecurity"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'array of alphabetic characters for encryption
Private Matrix(25, 25) As Byte
'###########################################
'### Public Properties, Subs & Functions ###
'###########################################
Public Function Encode(pMessage As String, pKeyWord As String, _
  Optional CaseCode As String) As String
  
'return the encode value of username
'If you need to decrypt rather than verify then
'you need to store the CaseCode as well
'Generate the CaseCode
CaseCode = Trim(CStr(CaseEncode(pMessage, _
   CaseCode)))

Encode = Encrypt(pMessage, pKeyWord)

End Function

Public Function Decode(pEncoded As String, pKeyWord As String, _
   Optional CaseCode As String) As String
   
    'return the decoded value of EnCoded Message
    Decode = Decrypt(pEncoded, pKeyWord)
    If CaseCode <> "" Then
        Decode = CaseDecode(Decode, CaseCode)
    End If
    
End Function

'###########################################
'### Private Properties, Subs & Functions ###
'###########################################
Private Sub BuildMatrix()
    Dim lColumn  As Integer
    Dim lRow     As Integer
    Dim lCharVal As Integer

'first character in the matrix is 'A'
lCharVal = 65
'cycle through all columns
For lColumn = 0 To 25
    'for each column, cycle through all rows
    For lRow = 0 To 25
        'insert the character's ascii value at the intersection
        Matrix(lColumn, lRow) = lCharVal
        'move on to the next character
        lCharVal = lCharVal + 1
        'if character > Z then cycle back to A
        If lCharVal = 91 Then lCharVal = 65
    Next lRow
    'the next column must start with 1 character higher than the current
    'column so increment the character
    lCharVal = lCharVal + 1
Next lColumn

End Sub

Private Function CaseDecode(pDecoded As String, _
 CaseCode As String) As String
'Code will look like this
'First Element is the number of Words
'Other elements indictate case of each letter
'1 = UPPERCASE
'0 = lowercase
'eg:
'     FailSafe Systems
'   2,10001000,1000000
'
Dim iWords    As Integer
Dim sWord     As String
Dim sCode     As String
Dim arrCode() As String
Dim x         As Integer
Dim n         As Integer

CaseDecode = ""
sCode = CaseCode
sCode = Replace(sCode, " ", "")

'If the lengths do not match then we cannot continue
If Len(pDecoded) <> Len(sCode) Then Exit Function

'First get everything in the proper case
For x = 1 To Len(sCode)
    If Mid(sCode, x, 1) = "1" Then
        Mid(pDecoded, x, 1) = UCase(Mid(pDecoded, x, 1))
    ElseIf Mid(sCode, x, 1) = "0" Then
        Mid(pDecoded, x, 1) = LCase(Mid(pDecoded, x, 1))
    End If
Next x

'now put in the proper spacing
arrCode = Split(CaseCode, " "): n = 1
For x = LBound(arrCode) To UBound(arrCode)
    CaseDecode = CaseDecode & Mid(pDecoded, _
       n, Len(arrCode(x))) & " "
    n = n + Len(arrCode(x))
Next x

CaseDecode = Trim(CaseDecode)
End Function

Private Function CaseEncode(pMessage As String, _
 CaseCode As String) As String
    
    'Generate the Case Code for the message
Dim arrCode() As String
Dim x         As Integer
Dim n         As Integer
Dim lChar     As String
Dim iChar     As Integer
Dim lWord     As String

arrCode = Split(pMessage, " ")
CaseEncode = ""

For x = LBound(arrCode) To UBound(arrCode)
    lWord = CStr(arrCode(x))
    For n = 1 To Len(lWord)
        lChar = Mid(lWord, n, 1)
        iChar = Asc(lChar)
        If iChar >= 65 And iChar <= 90 Then
            'UPPER CASE Letter
            CaseEncode = CaseEncode & "1"
        ElseIf iChar >= 97 And iChar <= 122 Then
            'lower case Letter
            CaseEncode = CaseEncode & "0"
        Else
            'NOT a letter
            CaseEncode = CaseEncode & "*"
        End If
    Next n
    CaseEncode = CaseEncode & " "
Next x
CaseEncode = Trim(CaseEncode)

End Function

Private Function Decrypt(pEncoded As String, _
   pKeyWord As String) As String
Dim x         As Integer
Dim xPos      As Integer
Dim yPos      As Integer
Dim lKeyPos   As Integer
Dim lCipher   As Integer
Dim lKeyLen   As Integer
Dim lKeyVal   As Integer
Dim lMsgVal   As Integer
Dim lLocation As Byte
Dim lKeyword  As String

Decrypt = ""
lKeyword = UCase(pKeyWord)
lKeyPos = 1
'convert the message to uppercase
pEncoded = UCase(pEncoded)
lKeyLen = Len(lKeyword)
If lKeyLen > 0 Then
    'cycle through each character in the message
    For x = 1 To Len(pEncoded)
        'return to the start of the keyword if
        'shorter than the message
        If lKeyPos > lKeyLen Then lKeyPos = 1
        lKeyVal = Asc(Mid(lKeyword, lKeyPos, 1))
        lMsgVal = Asc(Mid(pEncoded, x, 1))
        'if the current message character is valid, decode it
        If lMsgVal >= 65 And lMsgVal <= 90 Then
            'cycle through each row in the matrix until the
            'value is found
            For yPos = 0 To 25
                xPos = lKeyVal - 65
                lLocation = Matrix(xPos, yPos)
                If lLocation = lMsgVal Then
                    'the decoded character is the value
                    'of the row
                    Decrypt = Decrypt & Chr(yPos + 65)
                    'character found, stop searching
                    yPos = 25
                End If
            Next yPos
            lKeyPos = lKeyPos + 1
        End If
    Next x
End If

End Function

Private Function Encrypt(pMessage As String, _
   pKeyWord As String) As String
Dim x        As Integer
Dim xPos     As Integer
Dim yPos     As Integer
Dim lKeyPos  As Integer
Dim lCipher  As Integer
Dim lKeyLen  As Integer
Dim lKeyVal  As Integer
Dim lMsgVal  As Integer
Dim lKeyword As String

Encrypt = ""
lKeyword = UCase(pKeyWord)
lKeyPos = 1
'first convert to characters
'pMessage = TextToCipher(pMessage)
'convert the message to uppercase
pMessage = UCase(pMessage)
lKeyLen = Len(lKeyword)
If lKeyLen > 0 Then
    'cycle through each character in the message
    For x = 1 To Len(pMessage)
        'return to the start of the keyword if shorter
        'than the message
        If lKeyPos > lKeyLen Then lKeyPos = 1
        'get the value of the ascii character
        lKeyVal = Asc(Mid(lKeyword, lKeyPos, 1))
        lMsgVal = Asc(Mid(pMessage, x, 1))
        'if the current message character is valid, encode it
        If lMsgVal >= 65 And lMsgVal <= 90 Then
            xPos = lKeyVal - 65
            yPos = lMsgVal - 65
            lCipher = Matrix(xPos, yPos)
            Encrypt = Encrypt & Chr(lCipher)
            lKeyPos = lKeyPos + 1
        End If
    Next x
End If
End Function

    '##########################################
    '### Class Initialization & Termination ###


Private Sub Class_Initialize()
    'build the matrix
    BuildMatrix
End Sub

Private Sub Class_Terminate()
    'destroy everything here
End Sub

