Attribute VB_Name = "Globals"
Option Explicit

' Type Declarations
DefBool B   'Boolean
DefDbl D    'Double
DefLng H    'Long
DefInt I    'Integer
DefLng L    'Long
DefObj O    'Object
DefStr S    'String
DefDate T   'Time/Date
DefVar V    'Variant
'
'

'===================================================================================
'= Name:        GetFile
'= Programmer:  Casey W Manion - cwm engineering, inc
'= Purpose:     Returns array of strings loaded from a file
'=
'= Parameters:  sFileName - path & file name of file
'= Req'ments:   None
'= Notes:       No error if file isn't found
'===================================================================================
Public Function GetFile(ByVal sFileName) As String()
On Error GoTo Handle_Err:

    Dim sFile
    Dim iFile
     
    ReDim GetFile(0)
     
    ' Make sure exists
    If (Dir(sFileName) = "") Then Exit Function

    ' Open file | Read all in
    iFile = FreeFile
    Open sFileName For Binary Access Read As #iFile

        ' Get whole file
        sFile = String(LOF(iFile), 0)
        Get #iFile, , sFile

    ' Close
    Close #iFile
    
    ' Remove the vbcrlf's at the end
    Do Until (Right$(sFile, 2) <> vbCrLf)
        ' Shorten by 2
        sFile = Mid$(sFile, 1, Len(sFile) - 2)
    Loop
    
    ' Split by crlfs
    GetFile = Split(sFile, vbCrLf)

Exit Function
Handle_Err:
    
    ' Return this
    ReDim GetFile(0)

End Function

Public Sub LogHtml(ByVal sMsg)

    Dim iFile
    
    'Write events to event log
    iFile = FreeFile
    Open App.Path & "\" & App.EXEName & ".html" For Output As iFile
        Print #iFile, sMsg
    Close #iFile
    
    ' Launch
    Call Shell("C:\PROGRA~1\Plus!\MICROS~1\iexplore.exe " & App.Path & "\" & App.EXEName & ".html", vbMaximizedFocus)
    
End Sub



