VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VbToHtml"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'===================================================================================
'= Programmer:  Casey W Manion - cwm engineering, inc
'= Purpose:     Vb to Html Class
'=
'= Notes:       This is my first submission (please vote)!
'=
'= Thanks To:   Gary Walter E-mail: garylw@radiks.net
'=              http://www.freevbcode.com/ShowCode.Asp?ID=3165
'=              Access97 database that converted code to html
'===================================================================================
Option Explicit

' Type Declarations
DefBool B   'Boolean
DefDbl D    'Double
DefLng H    'Long
DefInt I    'Integer
DefLng L    'Long
DefObj O    'Object
DefStr S    'String
DefDate T   'Time/Date
DefVar V    'Variant
'
'

Private m_sBlueWords()  As String
Private m_sArrLines()   As String
Private m_sTitle        As String
Private m_sBody         As String
Private m_sDelimiter    As String
Private m_sHTML         As String
'

Private Sub Class_Initialize()

    ' Delimiter
    m_sDelimiter = vbCrLf
    
    ' Store blue words array (try default)
    m_sBlueWords = FileToArray(App.Path & "\BlueWords.dat")

    ' Store code array (try default)
    m_sArrLines = FileToArray(App.Path & "\" & App.Title & ".txt")

    ' Store default title
    m_sTitle = "<HTML>" & vbCrLf & _
               "<META HTTP-EQUIV=" & Chr$(34) & "Content-Type" & Chr$(34) & " " & _
               "CONTENT=" & Chr$(34) & "text/html;charset=windows-1252" & Chr$(34) & ">" & vbCrLf & _
               "<TITLE>" & "VbToHtml Class - [Default Title]" & "</TITLE>" & vbCrLf & _
               "<A NAME='Top'></A>" & vbCrLf
    
    
    ' Store body (nothing)
    m_sBody = "<BODY bgcolor='#FFFFFF'><Font Size = -1 Face = 'Courier New'></BODY>"

    ' Init as blank
    m_sHTML = ""
    
End Sub


'===================================================================================
'= Name:        BlueWordPath
'= Parameters:  Path to List of Words to highlight in blue
'= Notes:       Defaut is App.Title & "\BlueWords.dat"
'===================================================================================
Public Property Let BlueWordPath(ByVal sPath)

    ' Nothing passed
    If (Len(sPath) = 0) Then Exit Property
    
    ' Store member array
    m_sBlueWords = FileToArray(sPath)
    
End Property

'===================================================================================
'= Code
'===================================================================================
Public Property Get Code() As String

    If (Len(m_sHTML) = 0) Then
        ' Do the work in fx
        Code = ConvertToHtml
        
    Else
        ' Return
        Code = m_sHTML

    End If

End Property

Public Property Let Code(ByVal sCode)

    ' Remove extra Delimiters (vbCrlf's) at end of code
    '
    Do Until (Right$(sCode, Len(m_sDelimiter)) <> m_sDelimiter)
        ' Shorten by length of the Delimiter
        sCode = Mid$(sCode, 1, Len(sCode) - Len(m_sDelimiter))
    Loop
    
    ' Split into array by delimiter
    m_sArrLines = Split(sCode, m_sDelimiter)

    ' Reset
    m_sHTML = ""
    
End Property

'===================================================================================
'= CodeArray
'===================================================================================
Public Property Let CodeArray(ByRef sArrLines())

    ' Set array (assume vbCrlf delimited)...
    m_sArrLines = sArrLines

    ' Reset
    m_sHTML = ""

End Property

'===================================================================================
'= CodePath
'===================================================================================
Public Property Let CodePath(ByVal sPath)

    ' Nothing passed
    If (Len(sPath) = 0) Then Exit Property
    
    ' Store member
    m_sArrLines = FileToArray(sPath)

    ' Reset
    m_sHTML = ""

End Property

'===================================================================================
'= Delimiter
'===================================================================================
Public Property Let Delimiter(ByVal sDelimiter)
    
    ' Store member
    m_sDelimiter = sDelimiter
    
    ' Reset
    m_sHTML = ""
    
End Property

'===================================================================================
'= Title
'===================================================================================
Public Property Let Title(ByVal sTitle)

    ' Set up title
    m_sTitle = "<HTML>" & vbCrLf & _
               "<META HTTP-EQUIV=" & Chr$(34) & "Content-Type" & Chr$(34) & " " & _
               "CONTENT=" & Chr$(34) & "text/html;charset=windows-1252" & Chr$(34) & ">" & vbCrLf & _
               "<TITLE>" & sTitle & "</TITLE>" & vbCrLf & _
               "<A NAME='Top'></A>" & vbCrLf & _
               "<P><B><FONT SIZE=4 FACE='Times New Roman' COLOR='#000080'>" & _
               sTitle & _
               "</FONT>" & _
               "<FONT SIZE=3 FACE='Times New Roman' COLOR='#666666'>" & _
               "&nbsp;&nbsp;&nbsp;&nbsp;(<I>cwm engineering, inc.</I>)</FONT></B>" & _
               "<BR>" & vbCrLf & _
               "<BR>" & vbCrLf
               
    ' Reset
    m_sHTML = ""
             
End Property

'===================================================================================
'= ConvertToHtml
'===================================================================================
Private Function ConvertToHtml() As String
On Error Resume Next

    Dim lngI                ' Loop Counter
    Dim lPosTic             ' Position of Tick (') in line
    Dim lPosQuote           ' Position on Quote (") in line
    Dim lTicLine            ' Top line of continuous ticks before function
    Dim lLocBracket         ' Location of Bracket '(' in line
    Dim lLocSpace           ' Location of Space ' ' in line
    Dim sTrim               ' Trim$ of line
    Dim sLines              ' Joined string of array m_sArrLines()
    Dim sStart              ' First half of a quote/tick line
    Dim sEnd                ' Send half of a quote/tick line
    Dim bContinued          ' Commented and continued line (has a '_')
    Dim bPrevLineTic        ' Previous was commented line
    Dim sHeader             ' Header String that contains links to fx's
    Dim sFunction           ' Name of functions
    
    Dim colFunctions As Collection  ' Collection of functions
    
    
    ' Init (return)
    m_sHTML = ""
    ConvertToHtml = m_sTitle & m_sBody
    
    ' Collection
    Set colFunctions = New Collection
    
    ' Others
    bContinued = False
    bPrevLineTic = False
    lTicLine = 0

    ' Nothing passed
    If (UBound(m_sArrLines) = 0) Then Exit Function
    
    
    ' Loop through Code
    '
9   For lngI = 0 To UBound(m_sArrLines)

        ' Replaces common symbols
        '
        m_sArrLines(lngI) = Replace$(m_sArrLines(lngI), "&", "&amp;")
        m_sArrLines(lngI) = Replace$(m_sArrLines(lngI), "<", "&lt;")
        m_sArrLines(lngI) = Replace$(m_sArrLines(lngI), ">", "&gt;")


        ' Remove spaces at the end of any line
        m_sArrLines(lngI) = RTrim$(m_sArrLines(lngI))


        ' First if lines is a continued comment from previous line
        '   (note this doesn't match the IDE because the '_' will be green)
        '
10      If (bContinued) Then
            
            ' Continued again?
            bContinued = CBool(m_sArrLines(lngI) Like "*[_]")
            
            ' Not continued then complete line
            If Not (bContinued) Then
                m_sArrLines(lngI) = Replace$(m_sArrLines(lngI), Chr$(32), "&nbsp;") & _
                                    "</Font>"
            End If

        
        ' No line
        '
20      ElseIf (Len(m_sArrLines(lngI)) = 0) Then
        
            ' Not counted in declaration lines
            If (colFunctions.Count = 0) Then bPrevLineTic = False
                
                
        ' Tick at the beggining of the line
        '
30      ElseIf (Trim$(m_sArrLines(lngI)) Like "[']*") Then
        
            ' Get first tick like
            If Not (bPrevLineTic) Then lTicLine = lngI
            
            ' Prev line is a tick line
            bPrevLineTic = True
        
            ' Continued line
            bContinued = CBool(m_sArrLines(lngI) Like "*[_]")


            ' Process Line: Find position of Tick
            '
            lPosTic = InStr(1, m_sArrLines(lngI), "'")

            ' No spaces in front of tick
            If (lPosTic <= 1) Then
                ' Build string
                m_sArrLines(lngI) = "<Font Color='#007700'>" & _
                              Replace$(m_sArrLines(lngI), Chr$(32), "&nbsp;")
            
            ' Has spaces
            Else
                ' Build string
                m_sArrLines(lngI) = Replace$(String$((lPosTic - 1), "X"), "X", "&nbsp;") & _
                              "<Font Color='#007700'>'" & _
                              Replace$(Mid$(m_sArrLines(lngI), (lPosTic + 1)), Chr$(32), "&nbsp;")
            
            End If
            
            ' Not continued complete line
            If Not (bContinued) Then
                m_sArrLines(lngI) = m_sArrLines(lngI) & "</Font>"
            End If

        
        ' No Tick at the begginning of the line
        '
40      Else
            
            ' Remove spaces
            sTrim = Trim$(m_sArrLines(lngI))
            
            ' Previous Line didn't have ticks (header info)
            '
            If Not (bPrevLineTic) Then lTicLine = (lngI - 1)
            bPrevLineTic = False
            
            ' Check for Function/Sub/Property
            '   (note: assumes that you explicitly call Private or Public)
            '
            If (sTrim Like "P[u,r][b,i][l,v][i,a][c,t]*Function[ ]*[(]*[)]*") Or _
               (sTrim Like "P[u,r][b,i][l,v][i,a][c,t]*Sub[ ]*[(]*[)]*") Or _
               (sTrim Like "P[u,r][b,i][l,v][i,a][c,t]*Property[ ][G,L,S]et*[(]*[)]*") _
            Then
            
                ' Find first bracket | previous space (no checks due to if statement)
                '
                lLocBracket = InStr(1, sTrim, "(")
                lLocSpace = InStrRev(sTrim, Chr$(32), lLocBracket) + 1
                
                ' Get function name
                sFunction = Trim$(Mid$(sTrim, lLocSpace, Abs(lLocBracket - lLocSpace)))
                
                ' Reset
                Err.Number = 0
                Call colFunctions.Add(sFunction, sFunction)
                
                ' Add link if not already defined (properties get/let/set - only one)
                '
                If (Err.Number = 0) Then
                
                    ' Add <HR> Line and name reference
                    m_sArrLines(lTicLine) = "<HR>" & vbCrLf & _
                                            "<A NAME=" & sFunction & "></A>" & vbCrLf & _
                                            m_sArrLines(lTicLine)
                                    
                Else
                    ' Add <HR> before ticks
                    m_sArrLines(lTicLine) = "<HR>" & m_sArrLines(lTicLine)
                                    
                End If
                
            
            End If
            
                
            ' Get quote & tic
            lPosTic = InStr(1, m_sArrLines(lngI), Chr$(39))
            lPosQuote = InStr(1, m_sArrLines(lngI), Chr$(34))

            ' Found a tick in the line
            If (lPosTic <> 0) Then

                ' No quote or tick is first
                '
                If (lPosQuote = 0 Or lPosTic < lPosQuote) Then
                    
                    ' Continued line
                    bContinued = CBool(m_sArrLines(lngI) Like "*[_]")
                    
                    ' Split into two lines
                    '
                    sStart = BlueWords(Mid$(m_sArrLines(lngI), 1, (lPosTic - 1)))
                    sEnd = "<Font Color='#007700'>" & Replace$(Mid$(m_sArrLines(lngI), lPosTic), Chr$(32), "&nbsp;")

                    ' Combine
                    m_sArrLines(lngI) = sStart & sEnd
                    
                    ' Not continued complete line
                    If Not (bContinued) Then
                        m_sArrLines(lngI) = m_sArrLines(lngI) & "</Font>"
                    End If

                
                ' Quotes with following ticks
                '
                Else
                    ' Handle Quotes
                    m_sArrLines(lngI) = HandleQuotes(m_sArrLines(lngI), bContinued)
                    
                End If


            ' Found quotes in line
            '
            ElseIf (lPosQuote > 0) Then
                ' Handle Quotes
                m_sArrLines(lngI) = HandleQuotes(m_sArrLines(lngI), bContinued)


            ' Regular line
            '
            Else
                ' Send to blue words
                m_sArrLines(lngI) = BlueWords(m_sArrLines(lngI))

            End If

50      End If
        
        ' Replace quotes symbol | add break to line
        m_sArrLines(lngI) = Replace$(m_sArrLines(lngI), Chr$(34), "&quot;")
        m_sArrLines(lngI) = m_sArrLines(lngI) & "<BR>"
        
99  Next lngI
    
    
    ' Rejoin lines
    sLines = Join(m_sArrLines, vbCrLf)
    
        
    ' Found some functions
    If (colFunctions.Count > 0) Then
    
        ' Begging
        sHeader = "<FONT SIZE = 3 FACE = 'Times New Roman' COLOR = '#000000'>" & _
                    "&nbsp;&nbsp;&nbsp;&nbsp;<B>Functions/Properties/Subs</B><BR>" & vbCrLf
                    
        ' Loop throug all functions
        '
        For lngI = 1 To colFunctions.Count
            ' Update header
            sHeader = sHeader & _
                      "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" & _
                      "<A HREF='#" & colFunctions(lngI) & "'>" & colFunctions(lngI) & "</A><BR>" & vbCrLf
        Next lngI
                           
        ' Ending
        sHeader = sHeader & "<BR><BR></FONT>" & vbCrLf & "</P><HR>" & vbCrLf
    
    End If
    
    
    ' Body
    m_sBody = "<BODY bgcolor='#FFFFFF'><Font Size = -1 Face = 'Courier New'>" & vbCrLf & _
              sLines & vbCrLf & _
              "</BODY></HTML>"
            
    
    ' Store as member
    m_sHTML = m_sTitle & sHeader & m_sBody
    
    ' Return
    ConvertToHtml = m_sHTML
    
    ' Release
    Set colFunctions = Nothing

End Function

'===================================================================================
'= HandleQuotes
'===================================================================================
Private Function HandleQuotes(ByVal sString, ByRef bContinued) As String

    Dim sQuotes()
    Dim lngI
    Dim lPosTic
    Dim sStart
    Dim sEnd

    ' Init
    bContinued = False
    
    ' Split into array by quotes
    sQuotes = Split(sString, Chr$(34))

    ' Loop through array odds are quotes
    '
    For lngI = 1 To UBound(sQuotes) Step 2

        ' Replace$ tics in quotes with `temp tic`
        '
        sQuotes(lngI) = Replace$(sQuotes(lngI), Chr$(39), "`TempTic`")

    Next lngI

    ' Remake file using quotes (opposite of splitting)
    sString = Join(sQuotes, Chr$(34))


    ' See if we still have a tick (outside of quotes)
    '
    lPosTic = InStr(1, sString, Chr$(39))


    ' None found
    '
    If (lPosTic = 0) Then
        ' Split start by quotes (again)
        sQuotes = Split(sString, Chr$(34))


        ' Loop through array (this time looking for outside of quotes)
        '
        For lngI = 0 To UBound(sQuotes) Step 2

            ' Do blue words on each piece
            sQuotes(lngI) = BlueWords(sQuotes(lngI))

            If ((lngI + 1) < UBound(sQuotes)) Then
                ' Quotes
                sQuotes(lngI + 1) = "<Font Color='#660000'>" & sQuotes(lngI + 1) & "</Font>"
            End If

        Next lngI

        ' Remake this string
        sString = Join(sQuotes, Chr$(34))

    ' Found one
    Else
        
        ' Split into two lines | End are comments
        '
        sStart = Mid$(sString, 1, (lPosTic - 1))
        sEnd = "<Font Color='#007700'>" & Replace$(Mid$(sString, lPosTic), Chr$(32), "&nbsp;")

        ' Continued line
        bContinued = CBool(sEnd Like "*[_]")

        ' Not continued complete line
        If Not (bContinued) Then sEnd = sEnd & "</Font>"
        

        ' Split start by quotes (again)
        sQuotes = Split(sStart, Chr$(34))

        ' Loop through array (this time looking for outside of quotes)
        '
        For lngI = 0 To UBound(sQuotes) Step 2

            ' Do blue words on each piece
            sQuotes(lngI) = BlueWords(sQuotes(lngI))

            If ((lngI + 1) < UBound(sQuotes)) Then
                ' Quotes
                sQuotes(lngI + 1) = "<Font Color='#660000'>" & sQuotes(lngI + 1) & "</Font>"
            End If

        Next lngI

        ' Remake this string
        sStart = Join(sQuotes, Chr$(34))

        ' Combine with leading space
        sString = sStart & sEnd
        
    End If

    ' Replace$ temp tics
    HandleQuotes = Replace$(sString, "`TempTic`", Chr$(39))

End Function

'===================================================================================
'= BlueWords
'===================================================================================
Private Function BlueWords(ByVal sString) As String

    Dim lngI
    Dim sBlue

    ' Add beggining and trailing spaces
    sString = "&nbsp;" & Replace$(sString, Chr$(32), "&nbsp;") & "&nbsp;"

    ' Loop through all the words...
    '
    For lngI = 0 To UBound(m_sBlueWords)

        ' Get current blue
        sBlue = Trim$(m_sBlueWords(lngI))

        ' Can have values before
        '
        If (sBlue Like "[#]*") Then

            ' Remove #
            sBlue = Mid$(sBlue, 2)

            ' Check the string is found
            '
            If (sString Like "*[!0-z]" & sBlue & "[&]nbsp[;]*" Or _
                sString Like "*[&]nbsp[;]" & sBlue & "[&]nbsp[;]*") Then

                ' Replace$ all with blue words
                sString = Replace$(sString, _
                             sBlue & "&nbsp;", _
                             "<Font Color='#0000AA'>" & sBlue & "</Font>&nbsp;")
            End If


        ' Can have values after
        '
        ElseIf (sBlue Like "*[#]") Then

            ' Remove #
            sBlue = Mid$(sBlue, 1, (Len(sBlue) - 1))

            ' Check the string is found
            '
            If (sString Like "*[&]nbsp[;]" & sBlue & "[!0-z]*" Or _
                sString Like "*[&]nbsp[;]" & sBlue & "[&]nbsp[;]*") Then

                ' Replace$ all with blue words
                sString = Replace$(sString, _
                             "&nbsp;" & sBlue, _
                             "&nbsp;<Font Color='#0000AA'>" & sBlue & "</Font>")
            End If


        ' Stand alone (spaces)
        '
        Else
            ' Replace$ all with blue words
            sString = Replace$(sString, _
                        "&nbsp;" & sBlue & "&nbsp;", _
                        "&nbsp;<Font Color='#0000AA'>" & sBlue & "</Font>&nbsp;")

        End If


    Next lngI

    ' Remove 1st & last space...
    sString = Mid$(sString, Len("&nbsp;") + 1, Len(sString) - (2& * Len("&nbsp;")))

    ' Return replaced...
    BlueWords = sString

End Function

'===================================================================================
'= Name:        GetFile (changed to FileToArray to avoid confusion with global fx)
'= Purpose:     Returns array of strings loaded from a file
'= Parameters:  sFileName - path & file name of file
'= Notes:       No error if file isn't found
'===================================================================================
Private Function FileToArray(ByVal sFileName) As String()
On Error GoTo Handle_Err:

    Dim sFile
    Dim iFile
     
    ReDim FileToArray(0)
     
    ' Make sure exists
    If (Dir(sFileName) = "") Then Exit Function

    ' Open file | Read all in
    iFile = FreeFile
    Open sFileName For Binary Access Read As #iFile

        ' Get whole file
        sFile = String(LOF(iFile), 0)
        Get #iFile, , sFile

    ' Close
    Close #iFile
    
    ' Remove the vbcrlf's at the end
    Do Until (Right$(sFile, 2) <> vbCrLf)
        ' Shorten by 2
        sFile = Mid$(sFile, 1, Len(sFile) - 2)
    Loop
    
    ' Split by crlfs
    FileToArray = Split(sFile, vbCrLf)

Exit Function
Handle_Err:
    
    ' Return this
    ReDim FileToArray(0)

End Function

Public Sub LaunchHtml(Optional ByVal sFileName = "C:\TEMP\VbToHtml.html")
On Error Resume Next
    
    ' First things first
    If (Len(m_sHTML) = 0) Then ConvertToHtml

    ' Make sure somthing is there
    Call OutputHtmlToFile(sFileName)
    
    ' Launch (could find temp directory and iexplorer install - but hey works for me!
    Call Shell("C:\PROGRA~1\Plus!\MICROS~1\iexplore.exe " & sFileName, vbMaximizedFocus)
    
End Sub

Public Sub OutputHtmlToFile(Optional ByVal sFileName = "C:\TEMP\VbToHtml.html")
On Error Resume Next
    
    Dim iFile
    
    ' First things first
    If (Len(m_sHTML) = 0) Then ConvertToHtml
    
    'Write events to event log
    iFile = FreeFile
    Open sFileName For Output As iFile
        Print #iFile, m_sHTML
    Close #iFile
    
End Sub
