VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Const UndoMax = 5

Private mvarValue As String
Private UndoVar() As String
Private UndoCount As Integer
Public Event OnChange()

Public Sub Undo()
  If UndoCount = 0 Then Exit Sub
  mvarValue = UndoVar(UndoCount)
  UndoCount = UndoCount - 1
End Sub

Public Sub Clear()
  AsString = ""
  UndoCount = 0
  ReDim UndoVar(UndoCount)
End Sub

Public Function UpperCase() As String
  AsString = UCase(AsString)
  UpperCase = AsString
End Function

Public Function LowerCase() As String
  AsString = LCase(AsString)
  LowerCase = AsString
End Function

Public Function ReverseCase() As String
  Dim C As String
  Dim temp As String
  Dim t As Long
  
  
  temp = AsString
  For t = 1 To Len(temp)
    C = Mid(temp, t, 1)
    Mid(temp, t, 1) = GetCode(Asc(C))
  Next t
  
  AsString = temp
  ReverseCase = AsString
End Function

Private Function GetCode(num As Integer) As String
  Dim newnum As Integer
  
  newnum = num
  If num > 64 And num < 91 Then newnum = num + 32
  If num > 96 And num < 123 Then newnum = num - 32
  GetCode = Chr$(newnum)
End Function

Public Function Compare(Value As String) As Boolean
  Dim result As Integer
  result = StrComp(AsString, Value)
  If result = 0 Then Compare = True Else Compare = False
End Function

Public Function CompareNoCase(Value As String) As Boolean
  Dim result As Integer
  result = StrComp(AsString, Value, vbTextCompare)
  If result = 0 Then CompareNoCase = True Else CompareNoCase = False
End Function

Public Function Concat(Value As String) As String
  Concat = AsString + Value
End Function

Public Function ConcatA(Value As String) As String
  AsString = AsString + Value
  ConcatA = AsString
End Function

Public Function GetAt(Number As Integer) As String
  GetAt = Mid(AsString, Number, 1)
End Function

Public Sub SetAt(Value As String, Number As Integer)
  Dim temp As String
  temp = AsString
  Mid(temp, Number, 1) = Value
  AsString = temp
End Sub

Public Property Get Length() As Integer
   Length = Len(AsString)
End Property

Public Property Let AsCurrency(ByVal vData As Currency)
    AsString = CStr(vData)
End Property


Public Property Get AsCurrency() As Currency
    AsCurrency = CCur(AsString)
End Property


Public Function FormatMessage(FormatStr As String) As String
  FormatMessage = Format(AsString, FormatStr)
End Function

Public Function FormatString(Value, FormatStr As String) As String
  Dim temp As String

  temp = Format(Value, FormatStr)
  AsString = temp
  FormatString = AsString
End Function

Public Property Let AsInteger(ByVal vData As Integer)
    AsString = CStr(vData)
End Property

Public Property Get AsInteger() As Integer
    If IsNumeric(AsString) = True Then
      AsInteger = CInt(AsString)
    Else
      MsgBox "Value Not Numeric!", vbOKOnly, "Error", 0, 0
    End If
End Property

Public Property Let AsString(ByVal vData As String)
    On Error GoTo ValueLetErr
    Dim n As Long
    
    UndoCount = UndoCount + 1
    If UndoCount > UndoMax Then
      UndoCount = UndoMax
      ReDim Preserve UndoVar(UndoCount)
      For n = 1 To UndoMax
        UndoVar(n - 1) = UndoVar(n)
      Next n
    Else
      ReDim Preserve UndoVar(UndoCount)
    End If
    
    UndoVar(UndoCount) = mvarValue
    mvarValue = vData
    RaiseOnChange 'Calls Change event
    Exit Property

ValueLetErr:

MsgBox Err.Description

End Property


Public Property Get AsString() As String
    On Error GoTo ValueGetErr
    AsString = mvarValue
    Exit Property
ValueGetErr:

MsgBox Err.Description
End Property

Public Function MidStr(Start As Long, Optional Length As Integer) As String
  If Length <= 0 Then Length = 1
  MidStr = Mid(AsString, Start, Length)
End Function

Public Function LeftStr(Start As Long, Optional Length As Integer) As String
  If Length <= 0 Then Length = 1
  LeftStr = Left(AsString, Length)
End Function

Public Function RightStr(Start As Long, Optional Length As Integer) As String
  If Length <= 0 Then Length = 1
  RightStr = Right(AsString, Length)
End Function

Public Function MakeReverse() As String
  Dim temp1, temp2 As String
  Dim t As Long
  
  temp2 = AsString 'make it save for undo
  For t = Len(temp2) To 1 Step -1
    temp1 = temp1 + Mid$(temp2, t, 1)
  Next t
  AsString = temp1
  MakeReverse = temp1
End Function

Private Sub RaiseOnChange()
  RaiseEvent OnChange
End Sub
