Attribute VB_Name = "modWinRegistry"
Option Explicit
'***************************************************
'***************************************************
'*****      Application Registration Demo     ******
'*****             Registry Module            ******
'*****    John P. Cunningham - November 2001  ******
'*****   Web: http://johnpc.freeservers.com   ******
'*****      Email:  johnpc7@home.com          ******
'***************************************************
'***************************************************


Public Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Public Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long

Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002

Public Const ERROR_SUCCESS = 0&
Public Const REG_SZ = 1

'******************************************************************
'** The following Global Declaration is used to check which      **
'** Registry Root Key has been selected, i.e., HKEY_CURRENT_USER **
'** or HKEY_LOCAL_MACHINE                                        **
'******************************************************************
Global checkit As Boolean

Public Sub SaveSettingString(hKey As Long, strPath As String, strValue As String, strData As String)
Dim RKey As Long
Dim Result As Long

    Result = RegCreateKey(hKey, strPath, RKey)
    Result = RegSetValueEx(RKey, strValue, 0, REG_SZ, ByVal strData, Len(strData))
    Result = RegCloseKey(RKey)
    
End Sub

Public Sub DeleteValue(ByVal hKey As Long, ByVal strPath As String, ByVal strValue As String)

Dim RKey As Long
Dim Result As Long

    Result = RegOpenKey(hKey, strPath, RKey)
    Result = RegDeleteValue(RKey, strValue)
    Result = RegCloseKey(RKey)

End Sub

Public Function DeleteKey(ByVal hKey As Long, ByVal strKey As String)
Dim r As Long

    r = RegDeleteKey(hKey, strKey)
    
End Function

Public Function GetSettingString(hKey As Long, strPath As String, strValue As String, Optional Default As String) As String
Dim hCurKey As Long
Dim lValueType As Long
Dim strBuffer As String
Dim lDataBufferSize As Long
Dim intZeroPos As Integer
Dim lRegResult As Long

' Set up default value
If Not IsEmpty(Default) Then
  GetSettingString = Default
Else
  GetSettingString = ""
End If

' Open the key and get length of string
lRegResult = RegOpenKey(hKey, strPath, hCurKey)
lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, lValueType, ByVal 0&, lDataBufferSize)

If lRegResult = ERROR_SUCCESS Then

  If lValueType = REG_SZ Then
    ' initialise string buffer and retrieve string
    strBuffer = String(lDataBufferSize, " ")
    lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, 0&, ByVal strBuffer, lDataBufferSize)
    
    ' format string
    intZeroPos = InStr(strBuffer, Chr$(0))
    If intZeroPos > 0 Then
      GetSettingString = Left$(strBuffer, intZeroPos - 1)
    Else
      GetSettingString = strBuffer
    End If

  End If

Else
  ' there is a problem
End If

lRegResult = RegCloseKey(hCurKey)
End Function
Sub DelSetting(hKey As Long, strPath As String, strValue As String)
    Dim Ret As Variant
    'NB! Create a new key-must recreate the key with no actual setting
    RegCreateKey hKey, strPath, Ret
    'Delete the key's value
    RegDeleteValue Ret, strValue
    'close the key
    RegCloseKey Ret
End Sub
Public Sub UnloadAllForms()
Dim Form As Form
   For Each Form In Forms
      Unload Form
      Set Form = Nothing
   Next Form
End Sub
